#include "sys_config.h"
#if PRODUCT_SS
#include "sys_processor.h"
#include "UWater_eeprom_driver.h"
#include "UWater_valve_driver.h"
#include "UWater_Valve_app.h"
#include "UWater_rtcc_app.h"
#include "UWater_power_app.h"
#include "UWater_gp22_app.h"
#include "UWater_pt_app.h" 
#include "UWater_DataTools_App.h"
#include "UWater_QZ_Store_App.h"
#include "nb_upload_monitor.h"
#include "UWater_frame_func_ReplyNB.h"
#include "UWater_frame_func_ReplyShenShui.h"

static u8 s_eep_complete_ShenShui=0;
static u8 task_complete_ShenShui = PTL_PACK_BUSY;
static u8 g_frame_temp_buf_ShenShui[UP_BUF_SIZE];	//ݲֻ
static u16 g_frame_temp_len_ShenShui=0;
static DateTime shenshui_rtcc_time;

static STRUCT_FRAME_IES frame_struct_ShenShui; //ԼϢ 
static u8 *new_message_data_rev_ShenShui; 
static u8 up_deal_stat_ShenShui = UP_DEAL_S0;//Լ״̬
/*******ϴر*****************************************/
static u16 upload_serial_num_ShenShui=0;
static STRUCT_FRAME_IES upload_struct_ShenShui; //ԼϢ 
static u8 upload_frame_stat_ShenShui=0; //ϱ֡״̬
static u8 upload_task_complete_ShenShui = PTL_PACK_FAIL;  
static u16 upload_temp_len_ShenShui=0;//ϱݳ	
static UNION_SIGNAL signal_val;

static u8 upload_frame_retry_times=0;
static u8 temp_upload_step=0;
//static u8 temp_Supplemental_send_NO;
static u8 temp_store_msg=0;

//ɹԼϱ
static STRU_UPLOAD_FRAME upload_frame;//֡ϱ
static STRU_UPLOAD_FRAME store_frame;//֡洢,ϱ֡,ֹϱڼ洢
static STRU_SHORT_UPLOAD_FRAME short_upload_frame;//֡
//²Լ
static u8 supplement_data_frame_state = SUPPLEMENT_DATA_FRAME_S0;
static u8 supplement_cnt = 0;
static u8 supplement_buf[300];

//,洢
static TYP_STATE_SS step_save_supplt=SS_STATE_S0; 
static RTCC_To_Float old_jiange_total_flow;
static RTCC_To_Float new_jiange_total_flow;
static RTCC_UNION_2U8TOU16 jiange_data;
//־洢
static TYP_STATE_SS step_clear_flag=SS_STATE_S0; 
static u32 temp_supplement_bit;
//ϴ֡------------------------жϵӦ֣PTL_PACK_FAIL
//ˮͽˮϴӦͳһ
static void frame_func_reply_NB_AckUpload(void)
{
	g_frame_temp_len_ShenShui =0;
	u8 sernum0 = upload_serial_num_ShenShui&0xFF;
	u8 sernum1 = (upload_serial_num_ShenShui>>8)&0xFF;
	if(*(new_message_data_rev_ShenShui + 6) == 1)//ϱݸʽ쳣
	{
		if(frame_struct_ShenShui.serial_num0 == sernum0)//ˮԷظʽ쳣,ӦжϹ
		{
			if(frame_struct_ShenShui.serial_num1 == sernum1)
			{
				NB_SS_Control_SetPara(NB_SS_FormatError, 1);//ϱʽ쳣־
				FrameSetMsgApp(MsgNbUplaod_AckOk);//ſ,ֹ쳣ݵһֱ
			}
		}
	}
	else
	{
		if(frame_struct_ShenShui.serial_num0 == sernum0)
		{
			if(frame_struct_ShenShui.serial_num1 == sernum1)
			{
				FrameSetMsgApp(MsgNbUplaod_AckOk);
			}
		}
		NB_SS_Control_SetPara(NB_SS_FormatError, 0);//ϱʽ쳣־
	}
	task_complete_ShenShui = PTL_PACK_FAIL;//ϱӦ֡,ش,ƲӦ
}
//֡ϱӦ
static void frame_func_reply_NB_AckUploadShort(void)
{
	frame_func_reply_NB_AckUpload();
}
//²ԼӦ
static void frame_func_reply_NB_AckNewSupplement(void)
{
	frame_func_reply_NB_AckUpload();
}
//¼֡------------------------жϵӦ֣PTL_PACK_FAIL
static void frame_func_reply_NB_AckLogin(void)
{			
	FrameSetMsgApp(MsgNbUplaod_AckLoginOk);
}

static void ies_ack_upload_valve_frame(void)
{    
    g_frame_temp_len_ShenShui =0;
#if defined(VALVE)
	u8 sernum0 = upload_serial_num_ShenShui&0xFF;
	u8 sernum1 = (upload_serial_num_ShenShui>>8)&0xFF;
    u8 rcv_state = 0;
	rcv_state = *(new_message_data_rev_ShenShui + 6);
	if(*(new_message_data_rev_ShenShui + 6) == 1)//ϱݸʽ쳣
	{
		NB_SS_Control_SetPara(NB_SS_FormatError, 1);//ϱʽ쳣־
	}
	else
	{
		if(frame_struct_ShenShui.serial_num0 == sernum0)
		{
			if(frame_struct_ShenShui.serial_num1 == sernum1)
			{
				FrameSetMsgApp(MsgNbUplaod_AckOk);
			}
		}
		NB_SS_Control_SetPara(NB_SS_FormatError, 0);//ϱʽ쳣־
	}
    if(0x00 == (rcv_state & 0x06))	//-
    {
        ValveDealAppStart(VALVE_STATE_OPEN);
    }
    else if(0x02 == (rcv_state & 0x06))	//-չ
    {
        ValveDealAppStart(VALVE_STATE_CLOSE);
    }
    else if(0x04 == (rcv_state & 0x06))	//-Ȩ
    {
        ValveDealAppStart(VALVE_STATE_CLOSE_LOCK);
    }
    else if(0x06 == (rcv_state & 0x06))	//-Ӧ
    {
        ValveDealAppStart(VALVE_STATE_CLOSE_EMERGENCY);
    }
#endif
	task_complete_ShenShui = PTL_PACK_FAIL;//ϱӦ֡,ش,ƲӦ
}

//ʷ
static void frame_func_reply_NB_ReadHistoryData(void)
{
    u8 temp = 0;
    u8 temp_read_index = 0;
    u8 temp_read_code = *new_message_data_rev_ShenShui;   

    switch(up_deal_stat_ShenShui)
    {
        case UP_DEAL_S0:
        {
			if(TASK_IDLE == EepIfIdle())//ȡʷ
			{
				g_frame_temp_len_ShenShui =0;
				temp_read_index = NB_SS_Control_GetPara(NB_HistroyReadIndex);
				if (temp_read_index >= temp_read_code)
				{
					temp = temp_read_index - temp_read_code;
				}
				else
				{
					temp = 32 - (temp_read_code - temp_read_index);
				}
				EepRead((FRAME_NBIot_HISTORY_READ_ADD +(temp*PACK_NUM_GPRS)), g_frame_temp_buf_ShenShui, 155, &s_eep_complete_ShenShui);		
				up_deal_stat_ShenShui  = UP_DEAL_S1;
			}
        }
        break;

        case UP_DEAL_S1:
        {
            if(TASK_IDLE == EepIfIdle())//ȡʷ
            {
				g_frame_temp_len_ShenShui = PACK_NUM_GPRS;  
                task_complete_ShenShui = PTL_PACK_SUCCESS;                
                up_deal_stat_ShenShui  = UP_DEAL_S0;
            }
        }
        break;
      
        default:
        {
            up_deal_stat_ShenShui  = UP_DEAL_S0;
            task_complete_ShenShui = PTL_PACK_FAIL;
        }
        break;
    }    	 
}

//ʧܴ
static void frame_func_s3_NB_ClearFailTimes(void)
{   
	if(TASK_IDLE == EepIfIdle())
	{
		g_frame_temp_len_ShenShui = 0;
		NB_SS_Control_SetPara(NB_SS_FormatError, 0);
		NB_SS_Control_SetPara(NB_UploadFailTimes, 0);
		task_complete_ShenShui = PTL_PACK_SUCCESS;
	}
}
/************************************************************************************************************/
//ˮԼ
u8 crack_frame_ShenShui(u16 frame_lenth,u8 *frame_buffer)
{
	u8 temp_res = crack_frame_IES_Base(frame_lenth, frame_buffer, &frame_struct_ShenShui);
	if(temp_res == SUCCESS_IES)
	{		
		new_message_data_rev_ShenShui = frame_buffer + frame_struct_ShenShui.head_site + 16;								
		return  SUCCESS_IES;
	}
	return ERROR_IES;
}

//ˮԼ
u8 up_deal_code_ShenShui(void)
{
    task_complete_ShenShui = PTL_PACK_BUSY;
    switch(frame_struct_ShenShui.ctrl)
    {
		case SS_ACK_UPLOAD_CTRL:
		{
			frame_func_reply_NB_AckUpload();
		}
		break;
		case SHORT_ACK_UPLOAD_CTRL:
		{
			frame_func_reply_NB_AckUploadShort();
		}
		break;
		case SS_ACK_SIGN_IN_CTRL:
		{
			frame_func_reply_NB_AckLogin();
		}
		break;
		case ACK_UPLOAD_WITH_VAVLE_CTRL://ЯطָӦ֡
		{
			ies_ack_upload_valve_frame();
		}
		break;
		case SUPP_ACK_UPLOAD_CTRL://²ԼӦ
		{
			frame_func_reply_NB_AckNewSupplement();
		}
		break;
		case SS_CLEAR_FAIL_TIMES_CTRL:
		{
			frame_func_s3_NB_ClearFailTimes();
			frame_struct_ShenShui.ack_ctrl = SS_ACK_CLEAR_FAIL_TIMES_CTRL;
		}
		break;
		case SS_READ_HIS_CTRL:
		{
			switch(frame_struct_ShenShui.DI1)
			{
				case SS_READ_HIS_CTRL_ID1://ˮԼʷ
				{
					frame_func_reply_NB_ReadHistoryData();
				}
				break;
				default:
				{
					up_deal_stat_ShenShui  = UP_DEAL_S0;
					task_complete_ShenShui = PTL_PACK_FAIL; 
				}
			}
			frame_struct_ShenShui.ack_ctrl = SS_ACK_READ_HIS_CTRL;
		}
		break;
        default:
        {     
			up_deal_stat_ShenShui  = UP_DEAL_S0;
			task_complete_ShenShui = PTL_PACK_FAIL;           
        }
        break;
    }
    return task_complete_ShenShui;
}

void Frame_ResetDealState_ShenShui(void)
{
	up_deal_stat_ShenShui = UP_DEAL_S0;//չԼ״̬λ
}
//Ӧ֡
void Frame_ack_ShenShui(u8* p_send_buf, u16* p_send_len)
{
	STRUCT_FRAME_IES temp_struct;
	
	temp_struct.ack_ctrl = frame_struct_ShenShui.ack_ctrl;
	temp_struct.DI0 = frame_struct_ShenShui.DI0;
	temp_struct.DI1 = frame_struct_ShenShui.DI1;
	temp_struct.sta = frame_struct_ShenShui.sta;
	temp_struct.serial_num0 = frame_struct_ShenShui.serial_num0;
	temp_struct.serial_num1 = frame_struct_ShenShui.serial_num1;

	Frame_ack_IesBase(temp_struct,g_frame_temp_buf_ShenShui, g_frame_temp_len_ShenShui, p_send_buf, p_send_len);
}
/****************************************************************ϱݵĴ*********************************************/
static void setStoreMsg(SS_StoreMsgType msg, boolean_t bFlag)
{
    if(TRUE == bFlag)
    {
        temp_store_msg |= (1<<msg);
    }
    else
    {
        temp_store_msg &= (~(1<<msg));
    }    
}

static boolean_t getStoreMsg(SS_StoreMsgType msg)
{
	if(temp_store_msg & (1<<msg))
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

//ݰеĵǰϢ״̬
static void Upload_RenewCurrentData(STRU_UPLOAD_FRAME* temp_frame)
{
	MET_STATE temp_state; //״̬
	u8 temp1 = 0;
	Fram_To_Float tmp_float;
	u8* hight_flow; 
	DateTime tempRtcc_time;

	tmp_float.gp22_u32  = Gp30CheckDataApp(2);
	temp_frame->data.CurrentFlow.datas = (u32)(tmp_float.gp22_float*10);//ǰۼ
	temp_frame->data.CurrentFlowForward.datas = temp_frame->data.CurrentFlow.datas;//ǰۼ
	tmp_float.gp22_u32 = Gp30CheckDataApp(3);//ǰۻ
	temp_frame->data.CurrentFlowReverse.datas = (u32)(tmp_float.gp22_float*10);
	//ȡ:(4ֽ),ʱ(2ֽ),ʼʱ(8ֽ,Ԥ)	
	RtccCheck_Hight_Flow(&hight_flow);			
	for(temp1 = 0; temp1 <14 ;temp1++)
	{
		temp_frame->data.DailyHighestFlowAndTime[temp1] = *(hight_flow+temp1);
	}
	//ȡ:rsrp(2B),صѹ(2B),(2B),źŸǵȼecl(2B),CSQ(1B),ѹֵ(1B)
	temp_frame->data.UploadInfo = UploadGetInfo_Base();
	//ȡ:2B()X2(/h)X24h=96B
	/*
	ϱʱͨUPLOAD_DATA_READ_HISȡ0洢ʱͨUPLOAD_DATA_STEP_FLOWȡ
	*/
	//ϱʱ
	RtccGetDateTime(&tempRtcc_time);//ϱʱ
	temp_frame->data.UploadTime[0] = tempRtcc_time.s.second;
	temp_frame->data.UploadTime[1] = tempRtcc_time.s.minute;
	temp_frame->data.UploadTime[2] = tempRtcc_time.s.hour;
	temp_frame->data.UploadTime[3] = tempRtcc_time.s.day;
	temp_frame->data.UploadTime[4] = tempRtcc_time.s.month;
	temp_frame->data.UploadTime[5] = tempRtcc_time.s.year; 
	temp_frame->data.UploadTime[6] = 0x20;
	//״̬
	temp_state = FrameGetByte();
	temp_frame->data.StateBytes[0] = temp_state.stat0;
	temp_frame->data.StateBytes[1] = temp_state.stat1;
	temp_frame->data.StateBytes[2] = temp_state.stat2;
	temp_frame->data.StateBytes[3] = temp_state.stat3;
	temp_frame->data.StateBytes[4] = temp_state.stat4;
	//ۼƻԾʱ
	temp_frame->data.DailyActiveTime.datas = GetEventUploadType();//ϱ
}
//֡ϱ
static void Upload_RenewShortFrameData(void)
{
	DateTime tempRtcc_time;
	//
	short_upload_frame.data.null_buf.datas = 0; 
	short_upload_frame.data.CurrentFlow_short.datas = upload_frame.data.CurrentFlow.datas;//ǰۼ
	//ź\
	upload_frame.data.UploadInfo = UploadGetInfo_Base();
	short_upload_frame.data.RSRP_val = (u8)(upload_frame.data.UploadInfo.metinfo.RSRP_val/10);
	short_upload_frame.data.bat_voltage = PowerCheckValueSys();
	short_upload_frame.data.mode_snr = upload_frame.data.UploadInfo.metinfo.snr_val;
	short_upload_frame.data.mode_ecl = upload_frame.data.UploadInfo.metinfo.ecl_val;
	//ϱʱ
	RtccGetDateTime(&tempRtcc_time);
	short_upload_frame.data.UploadTime[0] = tempRtcc_time.s.minute;
	short_upload_frame.data.UploadTime[1] = tempRtcc_time.s.hour;
	short_upload_frame.data.UploadTime[2] = tempRtcc_time.s.day;
	short_upload_frame.data.UploadTime[3] = tempRtcc_time.s.month;
	short_upload_frame.data.UploadTime[4] = tempRtcc_time.s.year;
	//״̬
	short_upload_frame.data.StateBytes[0] = upload_frame.data.StateBytes[0];
	short_upload_frame.data.StateBytes[1] = upload_frame.data.StateBytes[1];
	short_upload_frame.data.StateBytes[2] = upload_frame.data.StateBytes[2];
	short_upload_frame.data.StateBytes[3] = 0x02;
	short_upload_frame.data.StateBytes[3] |= getUploadControlPara(UP_BAT_STATE);//ʣص
	//汾
	short_upload_frame.data.soft_ver.datas_map.data1 =(FrameCheckParaApp(FramePara_ProgVersion)>>16)&0xFF;
	short_upload_frame.data.soft_ver.datas_map.data0 =(FrameCheckParaApp(FramePara_ProgVersion)>>24)&0xFF;

	short_upload_frame.data.temp_value.datas = (u16)TempCheckValueApp();
}

//֡
void StartSupplementFrame(void)
{	
	supplement_data_frame_state = SUPPLEMENT_DATA_FRAME_S1;
}

u8 SupplementFrameMachineIfIdle(void)
{
	if(SUPPLEMENT_DATA_FRAME_S0 == supplement_data_frame_state)
	{
		return TASK_IDLE;
	}
	else
	{
		return TASK_BUSY;
	}
}

 //²֡
void SupplementFrameMachine(void)  
{ 
    switch(supplement_data_frame_state)
    {
        case SUPPLEMENT_DATA_FRAME_S0:
		break;
  
		case(SUPPLEMENT_DATA_FRAME_S1):
        {    
		   supplement_cnt = 0;
		   temp_supplement_bit = Sys_data_object.P1.Supplemental_send_flag.datas;
		   supplement_data_frame_state = SUPPLEMENT_DATA_FRAME_S2;
		}		
		break;
  
	    case(SUPPLEMENT_DATA_FRAME_S2):
		{  
			if(EepIfIdle())
			{   
				//ݲ־㲹ָ,ڴ
				Sys_data_object.P1.histroy_r = 0xFF;
				for (int i = Sys_data_object.P1.histroy_w; i >0; i--)
				{
					if (Sys_data_object.P1.Supplemental_send_flag.datas &(0x00000001<<i)) 
					{
						Sys_data_object.P1.histroy_r = i;
						break;
					}
				}
				if(Sys_data_object.P1.histroy_r == 0xFF)
				{
					for (int i = 31; i >(Sys_data_object.P1.histroy_w-1); i--)
					{
						if (Sys_data_object.P1.Supplemental_send_flag.datas &(0x00000001<<i)) 
						{
							Sys_data_object.P1.histroy_r = i;
							break;
						}
					}
				}
				if(supplement_cnt < SUPPLEMENT_DATA_MAX_NUM)
				{
					EepRead(FRAME_NBIot_HISTORY_READ_ADD+(Sys_data_object.P1.histroy_r*PACK_NUM_GPRS), &upload_frame.buf[0], PACK_NUM_GPRS, &s_eep_complete_ShenShui);
					supplement_data_frame_state = SUPPLEMENT_DATA_FRAME_S3;   
				}
				else
				{
					supplement_buf[0] = supplement_cnt;
					supplement_data_frame_state = SUPPLEMENT_DATA_FRAME_S0;
				} 
			}
		}	
		break;
  
		case(SUPPLEMENT_DATA_FRAME_S3):
		{  
			if(EepIfIdle())
			{ 
				supplement_buf[1+supplement_cnt*12+0] = upload_frame.data.UploadTime[3];
                supplement_buf[1+supplement_cnt*12+1] = upload_frame.data.UploadTime[4];
                supplement_buf[1+supplement_cnt*12+2] = upload_frame.data.UploadTime[5];
                supplement_buf[1+supplement_cnt*12+3] = upload_frame.data.StateBytes[1];
                supplement_buf[1+supplement_cnt*12+4] = upload_frame.data.CurrentFlow.datas_map.data0;
                supplement_buf[1+supplement_cnt*12+5] = upload_frame.data.CurrentFlow.datas_map.data1;
                supplement_buf[1+supplement_cnt*12+6] = upload_frame.data.CurrentFlow.datas_map.data2;
                supplement_buf[1+supplement_cnt*12+7] = upload_frame.data.CurrentFlow.datas_map.data3;
                supplement_buf[1+supplement_cnt*12+8] = 0; //Ԥ4ֽ
                supplement_buf[1+supplement_cnt*12+9] = 0;
                supplement_buf[1+supplement_cnt*12+10] = 0;
                supplement_buf[1+supplement_cnt*12+11] = 0;
				supplement_cnt++;
				supplement_data_frame_state = SUPPLEMENT_DATA_FRAME_S2;    
			}
		}
		break;
  
        default:
        {
            supplement_data_frame_state = SUPPLEMENT_DATA_FRAME_S0;
        }
        break;
    }
}

void GetUploadDataResetState_SS(void)
{
	upload_frame_stat_ShenShui =UP_DEAL_S0;
	upload_task_complete_ShenShui = PTL_PACK_BUSY;
}
u8 GetUploadDataCheckIdle_SS(void)
{
	if(UP_DEAL_S0 == upload_frame_stat_ShenShui)
    {
        return TASK_IDLE;
    }
    else
    {
        return TASK_BUSY;
    }
}
u8 GetUploadDataCheckTask_SS(void)
{
	return upload_task_complete_ShenShui;
}

void GetUploadDataMachine_SS(u8 data_step, u8* p_send_buf, u16* p_send_len)
{
	switch(upload_frame_stat_ShenShui)
	{
		case UP_DEAL_S0:
		{	
			if(data_step == UPLOAD_FRAME_REQUEST_NEW)//ݰ
			{
				temp_upload_step = 0;
				upload_frame_retry_times = 0;//ط0
				//Ҫȡϱݴ洢λ
				if(Sys_data_object.P1.histroy_w >= PERIOD_DATA_NUM)
				{
					Sys_data_object.P1.histroy_w = 0;
				}
				if(0 == Sys_data_object.P1.histroy_w)
				{
					Sys_data_object.P1.histroy_r = PERIOD_DATA_NUM - 1;
				}
				else
				{
					Sys_data_object.P1.histroy_r = Sys_data_object.P1.histroy_w-1;
				}
				setStoreMsg(SS_StoreMsg4,TRUE);//µǰ
				upload_frame_stat_ShenShui = UP_DEAL_S1;
			}
			else if(data_step == UPLOAD_FRAME_UPLOAD_OK)//ͳɹ
			{
				if(temp_upload_step == UP_DEAL_S1)//ǰͳɹ
				{
					SystemClearUploadAgain();//ش0
					setStoreMsg(SS_StoreMsg2, TRUE);//ǰͳɹ,λ(ʧܵ)
					upload_frame_retry_times = 0;
					 if(Sys_data_object.P1.func_cfg_bytes[7]==0x55)//Ҫ
					 {
						if(((FrameCheckParaApp(FramePara_FuncCfg8_11)>>8)&0xFF) == 0xAA)//²Լ
						{
							upload_frame_stat_ShenShui = UP_DEAL_S30;//²
						}
						else
						{
							upload_frame_stat_ShenShui = UP_DEAL_S10;//ȡ
						}
					 }
					 else//Ҫ
					 {
						NB_SS_Control_SetPara(NB_UploadFailTimes, 0);//ʧܱ־
						upload_task_complete_ShenShui = PTL_PACK_FAIL;// ʧ,ϱ 
						upload_frame_stat_ShenShui = UP_DEAL_S0;
					 }
				}
				else if(temp_upload_step == UP_DEAL_S10)//ͳɹ
				{
					setStoreMsg(SS_StoreMsg2, TRUE);//λ
					upload_frame_retry_times = 0;
					upload_frame_stat_ShenShui = UP_DEAL_S10;//ȡ
				}
				else if(temp_upload_step == UP_DEAL_S30)//²Լ
				{
					upload_frame_retry_times = 0;
					upload_frame_stat_ShenShui = UP_DEAL_S33;
				}
			}
			else if(data_step == UPLOAD_FRAME_UPLOAD_RETRY)//·
			{
				upload_frame_stat_ShenShui = UP_DEAL_S21;
				/*ɽӦ޸( ΪACKж,ʹ)
				upload_task_complete_ShenShui = PTL_PACK_FAIL;
				upload_frame_stat_ShenShui = UP_DEAL_S0;*/
			}
			else if(data_step == UPLOAD_FRAME_ONLINE_FAIL) //ʧ
			{
				//Ҫȡϱݴ洢λ(ڲ¼) 
				if(Sys_data_object.P1.histroy_w >= PERIOD_DATA_NUM)
				{
					Sys_data_object.P1.histroy_w = 0;
				}
				if(0 == Sys_data_object.P1.histroy_w)
				{
					Sys_data_object.P1.histroy_r = PERIOD_DATA_NUM - 1;
				}
				else
				{
					Sys_data_object.P1.histroy_r = Sys_data_object.P1.histroy_w-1;
				}
				if(	(UPLOAD_TYPE_TOUCH_KEY == GetEventUploadType()) || 
				(UPLOAD_TYPE_HAND_KEY == GetEventUploadType()))//ϱ
				{
					setStoreMsg(SS_StoreMsg1, TRUE);//ǲλ							
				}		
				else if(UPLOAD_TYPE_FIX_TIME == GetEventUploadType())//ʱϴ
				{
					setStoreMsg(SS_StoreMsg1, TRUE);//ǲλ
					SystemAddUploadAgain();//ش
				}
				else if(UPLOAD_TYPE_RETRY_AGAIN == GetEventUploadType())//ش
				{
					SystemAddUploadAgain();//ش
				}
				upload_task_complete_ShenShui = PTL_PACK_FAIL;
				upload_frame_stat_ShenShui = UP_DEAL_S0;
			}
			else 
			{
				upload_task_complete_ShenShui = PTL_PACK_FAIL;
				upload_frame_stat_ShenShui = UP_DEAL_S0;
			}
		}
		break;
		case UP_DEAL_S1://ȡ
		{
			if(step_save_supplt == SS_STATE_S0)//ݸ
			{
				if(EepIfIdle())
				{
					EepRead(FRAME_NBIot_HISTORY_READ_ADD+(Sys_data_object.P1.histroy_r*PACK_NUM_GPRS), &upload_frame.buf[0], PACK_NUM_GPRS, &s_eep_complete_ShenShui);
					temp_upload_step = UP_DEAL_S1;//¼ǰ״̬
					upload_frame_stat_ShenShui = UP_DEAL_S2;
				}
			}
		}
		break;
		case UP_DEAL_S2:
		{
			if(EepIfIdle())
			{
				Date g_date_miji;
				u8* miji_buf;
				//ݰϴܼɼ
				if(RtccCheckMsgApp(RtccMsg_MiJiCaiJi))//ѯܼɼǷѲɼ
				{
					//ܼʼʱ
					upload_frame.data.MiJiCaiJiStartTime[0]= Sys_data_object.P1.report_start_time[6]; 
					upload_frame.data.MiJiCaiJiStartTime[1]= Sys_data_object.P1.report_start_time[7];
					upload_frame.data.MiJiCaiJiStartTime[2]= Sys_data_object.P1.report_start_time[8];
					upload_frame.data.MiJiCaiJiStartTime[3]= g_date_miji.s.day;
					upload_frame.data.MiJiCaiJiStartTime[4]= g_date_miji.s.month;
					upload_frame.data.MiJiCaiJiStartTime[5]= g_date_miji.s.year;
					upload_frame.data.MiJiCaiJiStartTime[6]= 0x20; 
					RtccGetDate(&g_date_miji); //ϴʱΪܼʼʱ   
					Gp30CheckMiJiDataApp(&miji_buf);
					for(int tmp_j = 0; tmp_j <192;tmp_j++)
					{
						upload_frame.data.MiJiCaiJiFlow[tmp_j] = *(miji_buf  + tmp_j);
					}
					upload_temp_len_ShenShui = PACK_NUM_GPRS_TOTAL;
				}
				else
				{
					upload_temp_len_ShenShui = PACK_NUM_GPRS;//ܼϱݳ
				}
				upload_frame_stat_ShenShui = UP_DEAL_S20;
			}
		}
		break;
		case UP_DEAL_S10://ȡ
		{
			if(step_clear_flag == SS_STATE_S0)
			{
				if(EepIfIdle())
				{
					s_eep_complete_ShenShui = 0; 

					//ݲ־㲹ָ,ڴ
					Sys_data_object.P1.histroy_r = 0xFF;
					for (int i = Sys_data_object.P1.histroy_w; i >=0; i--)
					{
						if(Sys_data_object.P1.Supplemental_send_flag.datas &(0x00000001<<i)) 
						{
							Sys_data_object.P1.histroy_r = i;
							break;
						}
					}
					if(Sys_data_object.P1.histroy_r == 0xFF)
					{
						for(int i = 31; i >(Sys_data_object.P1.histroy_w-1); i--)
						{
							if (Sys_data_object.P1.Supplemental_send_flag.datas &(0x00000001<<i)) 
							{
								Sys_data_object.P1.histroy_r = i;
								break;
							}
						}
					}
				
					if(Sys_data_object.P1.histroy_r == 0xFF)//貹
					{
						upload_task_complete_ShenShui = PTL_PACK_FAIL;// ʧ
						upload_frame_stat_ShenShui = UP_DEAL_S0;
					} 
					else //Ҫ
					{
						EepRead(FRAME_NBIot_HISTORY_READ_ADD+(Sys_data_object.P1.histroy_r*PACK_NUM_GPRS), &upload_frame.buf[0], PACK_NUM_GPRS, &s_eep_complete_ShenShui);
						upload_temp_len_ShenShui = PACK_NUM_GPRS;
						temp_upload_step = UP_DEAL_S10;//¼ǰ״̬
						upload_frame_stat_ShenShui = UP_DEAL_S20;
					} 
				} 	
			}
		}
		break;
		
		case UP_DEAL_S20://ϴ֡
		{
			if(EepIfIdle())
			{
				if((FrameCheckParaApp(FramePara_FuncCfg8_11)&0xFF) == 0xAA)//֡ϱ
				{
					upload_struct_ShenShui.ack_ctrl = SHORT_UPLOAD_CTRL;
					upload_struct_ShenShui.DI0 = SHORT_UPLOAD_CTRL_ID0;
					upload_struct_ShenShui.DI1 = SHORT_UPLOAD_CTRL_ID1;
					upload_struct_ShenShui.sta = 0x03;//ϴ
					upload_serial_num_ShenShui++;
					upload_struct_ShenShui.serial_num0 = upload_serial_num_ShenShui&0xFF;
					upload_struct_ShenShui.serial_num1 = (upload_serial_num_ShenShui>>8)&0xFF; 
					upload_temp_len_ShenShui = STRU_DATA_LEN_IES_SHORT;
					Upload_RenewShortFrameData();//֡
					Frame_ack_IesBase(upload_struct_ShenShui, short_upload_frame.buf, upload_temp_len_ShenShui, p_send_buf, p_send_len);
				}
				else
				{
					upload_struct_ShenShui.ack_ctrl = SS_UPLOAD_CTRL;
					upload_struct_ShenShui.DI0 = SS_UPLOAD_CTRL_ID0;
					upload_struct_ShenShui.DI1 = SS_UPLOAD_CTRL_ID1;
					upload_struct_ShenShui.sta = 0x03;//ϴ
					upload_serial_num_ShenShui++;
					upload_struct_ShenShui.serial_num0 = upload_serial_num_ShenShui&0xFF;
					upload_struct_ShenShui.serial_num1 = (upload_serial_num_ShenShui>>8)&0xFF; 
					Frame_ack_IesBase(upload_struct_ShenShui, upload_frame.buf, upload_temp_len_ShenShui, p_send_buf, p_send_len);
				}
				upload_task_complete_ShenShui = PTL_PACK_SUCCESS;// ɹ
				upload_frame_stat_ShenShui = UP_DEAL_S0;
			}
		}
		break;

		case UP_DEAL_S21://
		{
			if(upload_frame_retry_times < 1) //Ϊط1
			{
				upload_frame_retry_times++;
				if(temp_upload_step == UP_DEAL_S30)//²Լ
				{
					upload_frame_stat_ShenShui = UP_DEAL_S32;
				}
				else
				{
					upload_frame_stat_ShenShui = UP_DEAL_S20;
				}
			} 
			else//·ʧ3εĴ
			{
				if(temp_upload_step == UP_DEAL_S1)//ǰʧ,жǷ񲹱
				{
					if(	(UPLOAD_TYPE_TOUCH_KEY == GetEventUploadType()) || 
					(UPLOAD_TYPE_HAND_KEY == GetEventUploadType()))//ǷŹرϱش
					{
						setStoreMsg(SS_StoreMsg1, TRUE);//temp_store_msg |= 0x02;//ǰλ,Ҽ¼Ҫ							
					}		
					else if(UPLOAD_TYPE_FIX_TIME == GetEventUploadType())//ʱϴ
					{
						setStoreMsg(SS_StoreMsg1, TRUE);//temp_store_msg |= 0x02;//ǰλ,Ҽ¼Ҫ
						SystemAddUploadAgain();//ش
					}
					else if(UPLOAD_TYPE_RETRY_AGAIN == GetEventUploadType())//ش
					{
						SystemAddUploadAgain();//ش
					}
				}
				upload_task_complete_ShenShui = PTL_PACK_FAIL;
				upload_frame_stat_ShenShui = UP_DEAL_S0;
			}
		}
		break;
		
		case UP_DEAL_S30://²Լ,֡ʼ
		{
			if(EepIfIdle())
			{
				temp_upload_step = UP_DEAL_S30;
				StartSupplementFrame();
				upload_frame_stat_ShenShui = UP_DEAL_S31;
			}
		}
		break;
		case UP_DEAL_S31://ȴȡ
		{
			SupplementFrameMachine();
			if(TASK_IDLE == SupplementFrameMachineIfIdle())
			{
				if(supplement_cnt)//Ϊ0˵вն
				{
					upload_frame_stat_ShenShui = UP_DEAL_S32;
				}
				else
				{
					upload_task_complete_ShenShui = PTL_PACK_FAIL;
					upload_frame_stat_ShenShui = UP_DEAL_S0;
				}
			}	
		}
		break;
		case UP_DEAL_S32://֡
		{
			if(EepIfIdle())
			{		 
				upload_struct_ShenShui.ack_ctrl = SUPP_UPLOAD_CTRL;
				upload_struct_ShenShui.DI0 = SUPP_UPLOAD_CTRL_ID0;
				upload_struct_ShenShui.DI1 = SUPP_UPLOAD_CTRL_ID1;
				upload_struct_ShenShui.sta = 0x03;//ϴ
				upload_serial_num_ShenShui++;
				upload_struct_ShenShui.serial_num0 = upload_serial_num_ShenShui&0xFF;
				upload_struct_ShenShui.serial_num1 = (upload_serial_num_ShenShui>>8)&0xFF; 
				upload_temp_len_ShenShui = supplement_cnt*12 + 1;
				Frame_ack_IesBase(upload_struct_ShenShui, supplement_buf, upload_temp_len_ShenShui, p_send_buf, p_send_len);
				upload_task_complete_ShenShui = PTL_PACK_SUCCESS;
				upload_frame_stat_ShenShui = UP_DEAL_S0;
			}
		}
		break;
		case UP_DEAL_S33://²־
		{
			if(EepIfIdle())
			{		
				Sys_data_object.P1.Supplemental_send_flag.datas = temp_supplement_bit;
				EepWrite(&Sys_data_object.P1.Supplemental_send_flag.datas_map.data0, FRAME_NBIot_BUBAO_FLAG, 6, &s_eep_complete_ShenShui);
				upload_frame_stat_ShenShui = UP_DEAL_S30;//ȡ
			}
		}
		break;
		
		default:
		{
			upload_task_complete_ShenShui = PTL_PACK_FAIL;
			upload_frame_stat_ShenShui = UP_DEAL_S0;
		}
		break;
	}
}
/*************************************************Լݴ洢****************************/
//ǰںʱ,
static DateTime_noweek getBackDateTimeNoWeek(u8 backDays)
{
	DateTime cdt;
	DateTime_noweek  cdt_noweek;
	struct tm tmdt;
	struct tm *ldt;
	time_t ctt;

	RtccGetDateTime(&cdt);//ȡǰʱ
	tmdt.tm_year = (cdt.s.year >> 4) * 10 + (cdt.s.year & 0x0F) + 100;
	tmdt.tm_mon = (cdt.s.month >> 4) * 10 + (cdt.s.month & 0x0F) - 1;
	tmdt.tm_mday = (cdt.s.day >> 4) * 10 + (cdt.s.day & 0x0F);
	tmdt.tm_hour = (cdt.s.hour >> 4) * 10 + (cdt.s.hour & 0x0F);
	tmdt.tm_min = (cdt.s.minute >> 4) * 10 + (cdt.s.minute & 0x0F);
	tmdt.tm_sec = (cdt.s.second >> 4) * 10 + (cdt.s.second & 0x0F);
	tmdt.tm_isdst = 0;
	ctt = mktime(&tmdt);
    //ʱǰ
	ctt -= backDays*24*3600;


	ldt = localtime(&ctt);

	cdt_noweek.s.year = ((*ldt).tm_year - 100) / 10 * 16 + ((*ldt).tm_year - 100) % 10;
	cdt_noweek.s.month = ((*ldt).tm_mon + 1) / 10 * 16 + ((*ldt).tm_mon + 1) % 10;
	cdt_noweek.s.day = ((*ldt).tm_mday) / 10 * 16 + ((*ldt).tm_mday) % 10;
	cdt_noweek.s.hour = ((*ldt).tm_hour) / 10 * 16 + ((*ldt).tm_hour) % 10;
	cdt_noweek.s.minute = ((*ldt).tm_min) / 10 * 16 + ((*ldt).tm_min) % 10;
	cdt_noweek.s.second = ((*ldt).tm_sec) / 10 * 16 + ((*ldt).tm_sec) % 10;
	return cdt_noweek;
}
//־洢
static void SS_Store_SuppleFlagMachine(void)
{
	switch(step_clear_flag)
	{
		case SS_STATE_S0:
		{
			if(getStoreMsg(SS_StoreMsg1) == TRUE)//油־
			{
				setStoreMsg(SS_StoreMsg1,FALSE);
				if((Sys_data_object.P1.func_cfg_bytes[0]>0)&&NbiotIfOnline())//ϱʱ,źֵ,򲻱
				{
					NB_SS_Control_SetPara(NB_UploadFailTimes, 0);
					step_clear_flag = SS_STATE_S0;
				}
				else
				{
					Sys_data_object.P1.Supplemental_send_flag.datas |=(0x00001<<Sys_data_object.P1.histroy_r);
					step_clear_flag = SS_STATE_S1;
				}
			}
			else if(getStoreMsg(SS_StoreMsg2) == TRUE)//嵱ǰ־
			{
				setStoreMsg(SS_StoreMsg2,FALSE);
				Sys_data_object.P1.Supplemental_send_flag.datas &=(~(0x0001<<(Sys_data_object.P1.histroy_r)));
				step_clear_flag = SS_STATE_S1;
			}
			else if(getStoreMsg(SS_StoreMsg5) == TRUE)//в־
			{
				setStoreMsg(SS_StoreMsg5,FALSE);
				Sys_data_object.P1.Supplemental_send_flag.datas = 0;
				step_clear_flag = SS_STATE_S1;
			}
		}
		break;
		case SS_STATE_S1:
		{
			if(EepIfIdle())
			{		
				EepWrite(&Sys_data_object.P1.Supplemental_send_flag.datas_map.data0, FRAME_NBIot_BUBAO_FLAG, 6, &s_eep_complete_ShenShui);
				step_clear_flag = SS_STATE_WAIT;
			}
		}
		break;
		case SS_STATE_WAIT:
		{
			if(EepIfIdle())
			{		
				step_clear_flag = SS_STATE_S0;
			}
		}
		break;

		default:
		{
			step_clear_flag = SS_STATE_S0;
		}
		break;
	}
}

//ݴ洢
static void SS_Store_CircleDataMachine(void)
{
	switch (step_save_supplt)//ݴ洢
	{
		case SS_STATE_S0://洢Ϣж
		{
			if (RtccCheckMsgApp(RtccMsg_OtherProtl))
			{
				RtccClearMsgApp(RtccMsg_OtherProtl);
				RtccGetDateTime(&shenshui_rtcc_time);
				if((shenshui_rtcc_time.s.minute==0x00)||(shenshui_rtcc_time.s.minute==0x30))
				{
					FrameSetMsgApp(MsgSS_JianGeStore);//Сʱ洢Ϣ
				}
				if ((shenshui_rtcc_time.s.hour == 0)&&(shenshui_rtcc_time.s.minute==0x00))//ʱ䵽
				{
					RtccSetMsgApp(RtccMsg_DataSave);//0¶
					FrameSetMsgApp(MsgSS_HisIndexStore);//0¶ָ
				}
			}	
			/**Ͷݴ洢0洢; Ȼ洢ָ; ʼµһּ洢,ڼждָЧ;*/
			if(RtccCheckMsgApp(RtccMsg_DataSave))//0㱣涳
			{
				RtccClearMsgApp(RtccMsg_DataSave);
				step_save_supplt = SS_STATE_S10;
			}
			else if(FrameCheckMsgApp(MsgSS_HisIndexStore))//0¶ָ
			{
				FrameClearMsgApp(MsgSS_HisIndexStore);
				step_save_supplt = SS_STATE_S2;
			}
			else if(FrameCheckMsgApp(MsgSS_JianGeStore)) //Сʱ洢
			{
				FrameClearMsgApp(MsgSS_JianGeStore);
				step_save_supplt = SS_STATE_S20;
			}
			else if(getStoreMsg(SS_StoreMsg4) == TRUE)//µǰ
			{
				setStoreMsg(SS_StoreMsg4,FALSE);
				step_save_supplt = SS_STATE_S30;
			}
			else if(FrameCheckMsgApp(Msg_ClearHisOther))//
			{
				FrameClearMsgApp(Msg_ClearHisOther);
				step_save_supplt = SS_STATE_S40;
			} 
			break;
		}
		/*0¶*/
		case SS_STATE_S10:
		{
			if(TASK_IDLE == EepIfIdle())
			{
				//(ֻ)±ݺͱ״̬
				Upload_RenewCurrentData(&store_frame);
			    EepWrite(store_frame.buf, (FRAME_NBIot_HISTORY_READ_ADD+(Sys_data_object.P1.histroy_w*PACK_NUM_GPRS)), CURRENT_DATA_INFO_LEN, &s_eep_complete_ShenShui);
				step_save_supplt = SS_STATE_S11;
			}
		    break;
		}
		case SS_STATE_S11://ϱʱ 
		{
			if(TASK_IDLE == EepIfIdle())
			{
			    EepWrite(&store_frame.data.UploadTime[0], (FRAME_NBIot_HISTORY_READ_ADD+(Sys_data_object.P1.histroy_w*PACK_NUM_GPRS)+UPLOAD_TIME_ADDR), 7, &s_eep_complete_ShenShui);
				step_save_supplt = SS_STATE_WAIT;
			}
		    break;
		}
		/*0¶ָ*/
		case SS_STATE_S2:
		{
			if(TASK_IDLE == EepIfIdle())
			{			
				Sys_data_object.P1.histroy_w++;
				if(Sys_data_object.P1.histroy_w>=PERIOD_DATA_NUM) 
				{
					Sys_data_object.P1.histroy_w=0; 
				}				
				Sys_data_object.P1.Supplemental_send_flag.datas &=(~(0x0001<<(Sys_data_object.P1.histroy_w)));//λò־
				EepWrite(&Sys_data_object.P1.Supplemental_send_flag.datas_map.data0, FRAME_NBIot_BUBAO_FLAG, 6, &s_eep_complete_ShenShui);
				step_save_supplt = SS_STATE_WAIT;
			}	
			break;					
		}
		/*洢*/
		case SS_STATE_S20://Сʱʱж:ֹ״ϵ,ڱ
		{
			if(EepIfIdle())
			{		
				if(	(shenshui_rtcc_time.s.year  == store_frame.data.StepFlowStartTime[5])&&
					(shenshui_rtcc_time.s.month == store_frame.data.StepFlowStartTime[4])&&
					(shenshui_rtcc_time.s.day   == store_frame.data.StepFlowStartTime[3]))
				{
					step_save_supplt = SS_STATE_S22;
				}
				else
				{	
					EepRead(FRAME_NBIot_HISTORY_READ_ADD+(Sys_data_object.P1.histroy_w*PACK_NUM_GPRS)+STEP_FLOW_TIME_ADDR, &store_frame.data.StepFlowStartTime[0], 7, &s_eep_complete_ShenShui);
					step_save_supplt = SS_STATE_S21;
				}
			}
		}
		break;
		case SS_STATE_S21:
		{
			if(EepIfIdle())
			{		
				if(	(shenshui_rtcc_time.s.year  == store_frame.data.StepFlowStartTime[5])&&
					(shenshui_rtcc_time.s.month == store_frame.data.StepFlowStartTime[4])&&
					(shenshui_rtcc_time.s.day   == store_frame.data.StepFlowStartTime[3]))
				{
					step_save_supplt = SS_STATE_S22;
				}
				else//Ч,еǰʼ
				{
					//ȡݺͱ״̬
					Upload_RenewCurrentData(&store_frame);
					//ϱźŲ
					store_frame.data.UploadInfo.metinfo.ecl_val =0;
					store_frame.data.UploadInfo.metinfo.RSRP_val =0;
					store_frame.data.UploadInfo.metinfo.single_val =0;
					store_frame.data.UploadInfo.metinfo.snr_val =0;
					//ʼʱ
					store_frame.data.StepFlowStartTime[0]= 0x00;
					store_frame.data.StepFlowStartTime[1]= 0x00;
					store_frame.data.StepFlowStartTime[2]= 0x00;
					store_frame.data.StepFlowStartTime[3]= shenshui_rtcc_time.s.day;
					store_frame.data.StepFlowStartTime[4]= shenshui_rtcc_time.s.month;
					store_frame.data.StepFlowStartTime[5]= shenshui_rtcc_time.s.year;        
					store_frame.data.StepFlowStartTime[6]= 0x20; 
					//:2B()X2(/h)X24h=96B
					for(int i = 0; i <96 ;i++)//
					{
						store_frame.data.StepFlow[i] = 0;
					}
					if(Sys_data_object.P1.histroy_w>=PERIOD_DATA_NUM) 
					{
						Sys_data_object.P1.histroy_w=0; 
					}
					EepWrite(store_frame.buf, (FRAME_NBIot_HISTORY_READ_ADD+(Sys_data_object.P1.histroy_w*PACK_NUM_GPRS)), PACK_NUM_GPRS, &s_eep_complete_ShenShui);
				}
			}
		}
		break;
		case SS_STATE_S22://洢ĳ
		{
			if(EepIfIdle())
			{		
				u16 temp_step_flow_addr=0;
				//
				new_jiange_total_flow.gp22_u32 = Gp30CheckDataApp(2);
				jiange_data.datas = (u16)((new_jiange_total_flow.gp22_float - old_jiange_total_flow.gp22_float)*10);
				old_jiange_total_flow.gp22_u32 = new_jiange_total_flow.gp22_u32;
			    //㱾ʱ̼洢λ
				temp_step_flow_addr = FRAME_NBIot_HISTORY_READ_ADD+(Sys_data_object.P1.histroy_w*PACK_NUM_GPRS)+STEP_FLOW_START_ADDR + 
				                      BCD2HEX(shenshui_rtcc_time.s.hour)*4 + (BCD2HEX(shenshui_rtcc_time.s.minute)/30)*2;
				EepWrite(&jiange_data.datas_map.data0, temp_step_flow_addr, 2, &s_eep_complete_ShenShui);
				step_save_supplt = SS_STATE_WAIT;
				//RtccAdjustDateTime(1,1800-10);//УʱСʱ//debug-----------------
			}
		}
		break;
		/*ϱǰ²Ҫȡϱ*/
		case SS_STATE_S30:
		{
			if(TASK_IDLE == EepIfIdle())
			{
				EepRead(FRAME_NBIot_HISTORY_READ_ADD+(Sys_data_object.P1.histroy_r*PACK_NUM_GPRS), &store_frame.buf[0], PACK_NUM_GPRS, &s_eep_complete_ShenShui);
				step_save_supplt = SS_STATE_S31;
			}
		}
		break;
		case SS_STATE_S31://²ϱʱ
		{
			if(TASK_IDLE == EepIfIdle())
			{
				DateTime_noweek tempTime;
				tempTime = getBackDateTimeNoWeek(1);
				RtccGetDateTime(&shenshui_rtcc_time);
				//Чж
				if(	(tempTime.s.year  != store_frame.data.StepFlowStartTime[5])||
					(tempTime.s.month != store_frame.data.StepFlowStartTime[4])||
					(tempTime.s.day   != store_frame.data.StepFlowStartTime[3]))
				{
					//ʼʱ
					store_frame.data.StepFlowStartTime[0]= 0x00;
					store_frame.data.StepFlowStartTime[1]= 0x00;
					store_frame.data.StepFlowStartTime[2]= 0x00;
					store_frame.data.StepFlowStartTime[3]= shenshui_rtcc_time.s.day;//޸Ϊǰʱ,ֹ
					store_frame.data.StepFlowStartTime[4]= shenshui_rtcc_time.s.month;
					store_frame.data.StepFlowStartTime[5]= shenshui_rtcc_time.s.year;        
					store_frame.data.StepFlowStartTime[6]= 0x20; 
					//:2B()X2(/h)X24h=96B
					for(int i = 0; i <96 ;i++)//
					{
						store_frame.data.StepFlow[i] = 0;
					}
				}
				Upload_RenewCurrentData(&store_frame);
			    EepWrite(store_frame.buf, (FRAME_NBIot_HISTORY_READ_ADD+ Sys_data_object.P1.histroy_r*PACK_NUM_GPRS), PACK_NUM_GPRS, &s_eep_complete_ShenShui);
				step_save_supplt = SS_STATE_WAIT;
			}
		}
		break;
		/*ݳʼдָ*/
		case SS_STATE_S40:
		{
			if(TASK_IDLE == EepIfIdle())
			{			
				//ʼ
				new_jiange_total_flow.gp22_u32 = Gp30CheckDataApp(2);
				old_jiange_total_flow.gp22_u32 = new_jiange_total_flow.gp22_u32;
				for(int i=0;i<7;i++)
				{
					store_frame.data.StepFlowStartTime[i]= 0x00;
				}
				Sys_data_object.P1.histroy_w = 0;
				Sys_data_object.P1.histroy_r = 0;
				Sys_data_object.P1.Supplemental_send_flag.datas = 0;//Ҳ0		
				EepWrite(&Sys_data_object.P1.Supplemental_send_flag.datas_map.data0, FRAME_NBIot_BUBAO_FLAG, 6, &s_eep_complete_ShenShui);
				step_save_supplt = SS_STATE_WAIT;
			}	
			break;					
		}
		case SS_STATE_WAIT:
		{
            if(TASK_IDLE == EepIfIdle())
            {
                 step_save_supplt = SS_STATE_S0;
            }
            break;
		}
        default:
        {
            break;		
        }			
    }
}
/*******************************************************************************
 * @fun_name:NB_SS_Control_GetPara
 * @brief   :    
 * @param[in] :ȡϱز
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
u8 NB_SS_Control_GetPara(NB_SS_ControlParaTypeDef paraType)
{
    switch(paraType)
	{
	    case NB_HistroyReadIndex://ʷݵĶָ
		{
			return Sys_data_object.P1.histroy_w;
		}
		case NB_UploadFailTimes://ʧܴ
		{
			u8 temp_fail_times=0;
			if(Sys_data_object.P3.ProductUpoadFailFlag)
			{
				temp_fail_times = Sys_data_object.P3.ProductUpoadFailFlag;
			}
			else
			{
				for(int i = 0; i < 32; i++)
				{
					if(((Sys_data_object.P1.Supplemental_send_flag.datas  >> i) & 0x00000001) == 0x00000001)
					{
						temp_fail_times += 1;
					}
				}
			}
			return temp_fail_times;
		}
		case NB_SS_FormatError://ϱݸʽ
		{
			return signal_val.SignalStruct.format_error;
		}
		default:
			break;
	}
	return 0;
}
/*******************************************************************************
 * @fun_name:NB_SS_Control_SetPara
 * @param[in] :ϱز
 ******************************************************************************/
void NB_SS_Control_SetPara(NB_SS_ControlParaTypeDef paraType, u8 data)
{
    switch(paraType)
	{
	    case NB_HistroyReadIndex://ʷݵĶָ
		{
			Sys_data_object.P1.histroy_w = data;
			break;
		}
		case NB_UploadFailTimes://ʧܴ
		{
			SystemClearUploadAgain();
			Sys_data_object.P1.Supplemental_send_flag.datas = data;
			Sys_data_object.P3.ProductUpoadFailFlag = 0;
			setStoreMsg(SS_StoreMsg5,TRUE);//temp_store_msg |= 0x20;//EEPROM
			break;
		}
		case NB_SS_FormatError://ϱݸʽ
		{
			signal_val.SignalStruct.format_error = data;
			break;
		}
		default:
			break;
	}
}
//Լݴ洢ֳʼ
void DataStoreInit(void)
{
	Quanzhou_Store_InitApp();
	if(Sys_data_object.P1.histroy_w>=PERIOD_DATA_NUM) 
	{
		Sys_data_object.P1.histroy_w=0; 
	}
	if(Sys_data_object.P1.histroy_r>=PERIOD_DATA_NUM) 
	{
		Sys_data_object.P1.histroy_r=0; 
	}
	old_jiange_total_flow.gp22_u32  = Gp30CheckDataApp(GP30_APP_TOTAL_FLOW);//ʼ
}
//Լݴ洢״̬
void DataStoreMachine(void)
{
	SS_Store_SuppleFlagMachine();//־洢
	SS_Store_CircleDataMachine();//ݴ洢
	Quanzhou_Store_Machine();//ݴ洢
}
//Լݴ洢ж
u8 DataStoreIfIdle(void)
{
    if((step_save_supplt == SS_STATE_S0)&&(step_clear_flag == SS_STATE_S0)&&(QuanzhouStore_IfSleep()==TRUE))
    {
        return TRUE;
    }
    else
    {
        return FALSE;
    }
}

#endif

