
#ifndef __UWater_SY_STORE_APP_H
#define __UWater_SY_STORE_APP_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "sys_config.h"
#if PRODUCT_SY
#include "UWater_frame_app.h"
#include "UWater_Rtcc_driver.h"

#define STORE_SIZE_DATA_CIRCLE            16  //ݵ
#define STORE_SIZE_DATA_FROZEN            32  //ݵ

#define EEP_DATA_LEN_CIRCLE   (STORE_SIZE_DATA_CIRCLE*24*6)//2352//ݴ洢ָ볤
	
#define EEP_ADDR_SY_STORE_CIRCLE            FRAME_SHENYANG_STORE_ADD //0x7300~0x7C00  16*24*6=2304=0x900
#define EEP_ADDR_SY_STORE_INDEX_CIRCLE     (EEP_ADDR_SY_STORE_CIRCLE + STORE_SIZE_DATA_CIRCLE*24*6) //ݴ洢ָ__48BYTE
#define EEP_ADDR_SY_STORE_INDEX_DAILY      (EEP_ADDR_SY_STORE_INDEX_CIRCLE + 66)////ݴ洢ָ_ն_1BYTE
#define EEP_ADDR_SY_STORE_INDEX_MONTH      (EEP_ADDR_SY_STORE_INDEX_DAILY + 1)////ݴ洢ָ_¶_1BYTE
#define EEP_ADDR_SY_STORE_INDEX_YEAR       (EEP_ADDR_SY_STORE_INDEX_MONTH + 1)////ݴ洢ָ_궳_1BYTE
#define EEP_ADDR_SY_FIRST_PWON             (EEP_ADDR_SY_STORE_INDEX_YEAR + 1)
//洢ַ
#define EEP_ADDR_SY_TLVDATA                (EEP_ADDR_SY_FIRST_PWON+1)  //104ֽ

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define EEP_DATA_LEN_FROZEN   (STORE_SIZE_DATA_FROZEN*31)//995//ݴ洢ָ볤
	
#define EEP_ADDR_SY_STORE_FROZEN_DAILY      EEP_RTCC_APP_HISTORY_ADDR //0x440 ն(32*7)
#define EEP_ADDR_SY_STORE_FROZEN_MONTH     (EEP_ADDR_SY_STORE_FROZEN_DAILY + STORE_SIZE_DATA_FROZEN*7)  //¶(32*18)
#define EEP_ADDR_SY_STORE_FROZEN_YEAR      (EEP_ADDR_SY_STORE_FROZEN_MONTH + STORE_SIZE_DATA_FROZEN*18) //궳(32*6)

#define SY_FIRST_POWERON_FLAG  0x56

typedef union  //ǿתΪ
{
    u32   gp22_u32;
    float gp22_float;
    u8 buf[4];
}SY_U32_To_Float;

//ݴ洢ָ
typedef enum
{
    SY_StoreCurIndex_Daily = 0,//ն洢ָ
	SY_StoreCurIndex_Month = 1,//¶洢ָ
	SY_StoreCurIndex_Year  = 2//¶洢ָ
} SY_ParaTypeDef;

//ݽṹ
typedef union 
{
	struct
	{
		u32 CurrentFlow;//ۼ
		u32 CurrentFlowReverse;//ۼ
		u32 InstantaneousFlow;//˲ʱ
		u16 Presure;//ѹ
		u16 Temprature;//¶
	}Data;
	u8 data_buf[STORE_SIZE_DATA_CIRCLE];
}UNION_SY_STORE_CIRCLE;

//ݴ洢ṹ
typedef union 
{
	struct
	{
		DateTime CircleDataTime;//ʱ(),Ϊ0,ʹDateTimeʽDateTime_noweekʽ,ѱڼ
		u8 CircleCntStart;
		u8 CircleCntEnd;
		u8 ReadStart; //ȡʱʹ
		u8 ReadEnd;
	}Data;
	u8 data_buf[11];
}TYPE_CIRCLE_INDEX;

typedef union 
{
	TYPE_CIRCLE_INDEX CircleIndex[6];
	u8 data_buf[66];
}UNION_SY_STORE_CIRCLE_INDEX;

//ݴ洢ָ
#define SIZE_SY_STORE_INDEX  (11*6+3+1)//70
typedef union 
{
	struct
	{
		UNION_SY_STORE_CIRCLE_INDEX Circle;//ݴ洢ָ
		u8 Daily;//նݴ洢ָ
		u8 Month;//¶ݴ洢ָ
		u8 Year;//궳ݴ洢ָ
		u8 firstPowerOn;//һϵ־
	}Data;
	u8 data_buf[SIZE_SY_STORE_INDEX];
}UNION_SY_STORE_INDEX;

//ݽṹ
/**
	3
ʱ	3
ۼ	4
ۼ	4
ֵ	4
ֵʱ	3
صѹ	6
ˮ״̬	1
ˮ	1
״̬	1
Ԥ	1
У	1
ֽ	32
*/
typedef union 
{
	struct
	{
		DateTime_noweek FrozenDataTime; //ʱ      6                         
		u32 CurrentFlow;//ۼ           4
		u32 CurrentFlowReverse;//ۼ    4
		u32 PeakCurrentFlow;//ֵ	         4
		u8  PeakCurrentFlowTime[3];//ʱ      3
		u8  BatPower[6];//صѹ	             6
		u8  MeterState;//ˮ״̬	             1
		u8  MeterFault;//ˮ	             1
		u8  ValveState;//״̬	             1
		u8  Reverse;   //Ԥ                    1
		u8 CheckSum;//                           1
	}Data;
	u8 data_buf[STORE_SIZE_DATA_FROZEN];
}UNION_SY_STORE_FROZEN;

/**TLV ݸʽĲ**/
typedef enum
{
	TagWarningId = 0, //ʱID
	TagOverFlowCurrent = 1, //ֵλ0.1L/H
	TagOverFlowMinute = 2, //ʱ
	TagReverseFlowCurrent = 3, //ֵλ0.1L/H
	TagReverseFlowMinute = 4, //ʱ
	TagLeakFlowMinute = 5, //©ˮʱ
	TagPowerLow001V = 6, //ѹֵ
	TagNoWaterMinute = 7, //չܱʱ
	TagValveState    = 8, //״̬
	TagUploadStartTime = 12,   //ϱʼʱa
	TagCircleData5Minutes = 13,//ʱa
	TagDataFrozenTimeDailay = 14,//նʱ
	TagDataFrozenTimeMonth = 15,   //¶ʱ
	TagUploadRetryTimes = 16,//ϱط
	TagUploadRetryDelayMinite = 17,//طʱʱ
	TagUploadIntervalHour = 18,//ϱʱa
	TagServerIpPort = 21,    //ַa
	TagAPN = 22,    //APNϢ
	TagWorkTime = 31    //ˮʱ
	
}TypeDef_TLVTag;

typedef enum
{
	LenWarningId = 2, //ʱID-----------------------------2
	LenOverFlowCurrent = 4, //ֵλ0.1L/H-------4
	LenOverFlowMinute = 1, //ʱ----------------------1
	LenReverseFlowCurrent = 4, //ֵλ0.1L/H----4
	LenReverseFlowMinute = 1, //ʱ---------------1
	LenLeakFlowMinute = 1, //©ˮʱ----------------------1
	LenPowerLow001V = 2, //ѹֵ------------------------2
	LenNoWaterMinute = 1, //չܱʱ-----------------------1
	LenValveState    = 7, //״̬---------------------------7
	LenUploadStartTime = 4,    //ϱʼʱa-------------4
	LenCircleData5Minutes = 1, //ʱa-------------1
	LenDataFrozenTimeDailay = 1, //նʱ------------------1
	LenDataFrozenTimeMonth = 2,    //¶ʱ----------------2
	LenUploadRetryTimes = 1, //ϱط--------------------1
	LenUploadRetryDelayMinite = 1, //طʱʱ--------------1
	LenUploadIntervalHour = 1, //ϱʱa-------------1
	LenServerIpPort = 32,    //ַa--------------------32
	LenAPN = 32,    //APNϢ---------------------------------32
	LenWorkTime = 6     //ˮʱ-------------------------6
}TypeDef_TLVDataLen;

//ˮ
#define TLV_VALUE_LEN  104
typedef union 
{
	struct 
	{
		u8  ValueWarningId[2];//ʱID--------------------------2
		u8  ValueOverFlowCurrent[4];//ֵλ0.1L/H----4
		u8  ValueOverFlowMinute;//ʱ----------------------1
		u8  ValueReverseFlowCurrent[4];//ֵλ0.1L/H-4
		u8  ValueReverseFlowMinute;//ʱ---------------1
		u8  ValueLeakFlowMinute;//©ˮʱ----------------------1
		u8  ValuePowerLow001V[2];//ѹֵ---------------------2
		u8  ValueNoWaterMinute;//չܱʱ-----------------------1
		u8  ValueValveState[7];//״̬---------------------------7
		u8  ValueUploadStartTime[4];//ϱʼʱa-------------4
		u8  ValueCircleData5Minutes;//ʱa-------------1
		u8  ValueDataFrozenTimeDailay;//նʱ------------------1
		u8  ValueDataFrozenTimeMonth[2];//¶ʱ----------------2
		u8  ValueUploadRetryTimes;//ϱط--------------------1
		u8  ValueUploadRetryDelayMinite;//طʱʱ--------------1
		u8  ValueUploadIntervalHour;//ϱʱa-------------1
		u8  ValueServerIpPort[32];//ַa--------------------32
		u8  ValueAPN[32];//APNϢ---------------------------------32
		u8  ValueWorkTime[6];//ˮʱ-------------------------6
	}s;
	u8 data_buf[TLV_VALUE_LEN];
}Type_TLVValue;

typedef enum
{
	AddrWarningId = 0, //ʱID-----------------------------2
	AddrOverFlowCurrent = 2, //ֵλ0.1L/H-------4
	AddrOverFlowMinute = 6, //ʱ----------------------1
	AddrReverseFlowCurrent = 7, //ֵλ0.1L/H----4
	AddrReverseFlowMinute = 11,//ʱ---------------1
	AddrLeakFlowMinute = 12,//©ˮʱ----------------------1
	AddrPowerLow001V = 13,//ѹֵ------------------------2
	AddrNoWaterMinute = 15,//չܱʱ-----------------------1
	AddrValveState    = 16,//״̬---------------------------7
	AddrUploadStartTime = 23,   //ϱʼʱa-------------4
	AddrCircleData5Minutes = 27,//ʱa-------------1
	AddrDataFrozenTimeDailay = 28,//նʱ------------------1
	AddrDataFrozenTimeMonth = 29,   //¶ʱ----------------2
	AddrUploadRetryTimes = 31,//ϱط--------------------1
	AddrUploadRetryDelayMinite = 32,//طʱʱ--------------1
	AddrUploadIntervalHour = 33,//ϱʱa-------------1
	AddrServerIpPort = 34,    //ַa--------------------32
	AddrAPN = 66,    //APNϢ---------------------------------32
	AddrWorkTime = 98    //ˮʱ-------------------------6
}TypeDef_TLVDataAddr;

typedef struct 
{
	const TypeDef_TLVTag Tag;
	const TypeDef_TLVDataLen Len;
	TypeDef_TLVDataAddr ValueAddr; 
	u8 EditFlag;//Ƿ޸,0޸,  1޸
} TypeDef_TLVStruct; 

#define TLV_STR_BUF_LEN   19
static TypeDef_TLVStruct TlvStrBuf[TLV_STR_BUF_LEN]={
	{TagWarningId,               LenWarningId,                AddrWarningId,          0},
	{TagOverFlowCurrent,         LenOverFlowCurrent,          AddrOverFlowCurrent,    0},
	{TagOverFlowMinute,          LenOverFlowMinute,           AddrOverFlowMinute,     0},
	{TagReverseFlowCurrent,      LenReverseFlowCurrent,       AddrReverseFlowCurrent, 0},
	{TagReverseFlowMinute,       LenReverseFlowMinute,        AddrReverseFlowMinute,  0},
	{TagLeakFlowMinute,          LenLeakFlowMinute,           AddrLeakFlowMinute,     0},
	{TagPowerLow001V,            LenPowerLow001V,             AddrPowerLow001V,       0},
	{TagNoWaterMinute,           LenNoWaterMinute,            AddrNoWaterMinute,      0},
	{TagValveState,              LenValveState,               AddrValveState,         0},
	{TagUploadStartTime,         LenUploadStartTime,          AddrUploadStartTime,    0},
	{TagCircleData5Minutes,      LenCircleData5Minutes,       AddrCircleData5Minutes, 0},
	{TagDataFrozenTimeDailay,    LenDataFrozenTimeDailay,     AddrDataFrozenTimeDailay,  0},
	{TagDataFrozenTimeMonth,     LenDataFrozenTimeMonth,      AddrDataFrozenTimeMonth,   0},
	{TagUploadRetryTimes,        LenUploadRetryTimes,         AddrUploadRetryTimes,      0},
	{TagUploadRetryDelayMinite,  LenUploadRetryDelayMinite,   AddrUploadRetryDelayMinite,0},
	{TagUploadIntervalHour,      LenUploadIntervalHour,       AddrUploadIntervalHour,    0},
	{TagServerIpPort,            LenServerIpPort,             AddrServerIpPort,          0},
	{TagAPN,                     LenAPN,                      AddrAPN,                   0},
	{TagWorkTime,                LenWorkTime,                 AddrWorkTime,              0}
};
/*ϱ־λ
0	
1	չܱ
2	
3	©ˮ
4	͵ѹ
5	¶ȳΧ
6	ϸǱ
7	Ŷ
8-11	Ԥ
12-15	Զ
*/
typedef enum
{
	UPLOAD_OVER_FLOW = 0,//--
	UPLOAD_NO_WATER, //չܱ--
	UPLOAD_REVERSE_FLOW, //--
	UPLOAD_LEAK_FLOW,//©ˮ--
	UPLOAD_LOW_POWER,//͵ѹ---
	UPLOAD_TEMP_OVER,//¶ȳΧ--
	UPLOAD_SHELL_OPEN,//ϸǱ
	UPLOAD_VALVE_CHANGE//Ŷ--
}TypeDef_UploadWarning;
/*״̬*/
typedef enum{	
	SY_STATE_S0 = 0,
	SY_STATE_S1,
	SY_STATE_S2,
	SY_STATE_S3,
	SY_STATE_S4,
	SY_STATE_S5,
	SY_STATE_S6,
	SY_STATE_S7,
	SY_STATE_S8,
	SY_STATE_S9,
	SY_STATE_S10,
	SY_STATE_S11,
	SY_STATE_S12,
	SY_STATE_S13,
	SY_STATE_S20,
	SY_STATE_S21,
	SY_STATE_S22,
	SY_STATE_S30,
	SY_STATE_S31,
	SY_STATE_S32,
	SY_STATE_S40,
	SY_STATE_S41,
	SY_STATE_S42,
	SY_STATE_S50,
	SY_STATE_S51,
	SY_STATE_S52,
	SY_STATE_S60,
	SY_STATE_S61,
	SY_STATE_S62,
	SY_STATE_S70,
	SY_STATE_S71,
	SY_STATE_S72,
	SY_STATE_S80,
	SY_STATE_S81,
	SY_STATE_S82,
	SY_STATE_S90,
	SY_STATE_S91,
	SY_STATE_S92
}TYP_STATE_SY;




void ShenYang_Store_InitApp(void);
void ShenYang_Store_Machine(void);
void ShenYang_SOE_Machine(void);
u8 get_SY_StorePara(SY_ParaTypeDef paraType);
u8 ShenYangStore_IfSleep(void);
//int NB_SY_Frame_Upload_Warning(u8 *pBuf);

u8 getSY_StoreCircleIndex(void);
u8 getSY_CircleUploadPackets(void);
u8 getSY_ThisCirclePacket_Index(u8 current_packet);
int NB_SY_Frame_Upload_Data(u8 index, u8 *pBuf);
int NB_SY_Frame_Upload_CurrentData(u8 *pBuf);
void SY_GetCircleDateTime(DateTime *pDT, u8 index, u8 UploadOrRead);
u8 SY_GetCircleReadStartEnd(u8 index, u8 StartOrEnd);
int ShenYang_CircleDataStore_ClearUploadIndex(u8 index);
void ShenYang_TlvDataStoreMachine(void);
//ǰںʱ,
DateTime getBackDateTime(u8 backDays);
//ǰںʱ,
DateTime_noweek getBackDateTimeNoWeek(u8 backDays);
u8 getSY_CircleDataPackets(u8 readDays, u8 *pIndexBuf);
u8 checkWarningUploadState(TypeDef_UploadWarning tWarningType);
u8 GetTLVData(u8 Tag, u8 Len, u8* pValue);
u8 SetTLVData(u8 Tag, u8 Len, u8* pValue);
u8 getTlvTagIndex(u8 inTag);
u8 getWaterState(void);

#endif

#ifdef __cplusplus
}
#endif

#endif /* __UWater_JIANGXISTORE_APP_H */

/***************************************************************END OF FILE****/
