/************************************************************************************
 * @Copyright (c)    :(C)2021, Qindao ieslab Co., Ltd
 * @FileName   	     :ble_driver.h
 * @Author           :QDIES PLATFORM TEAM
 * @Version          :V1.1
 * @Date             :2021-7
 * @Description     :
 ************************************************************************************/

#ifndef __BLE_DRIVER_H
#define	__BLE_DRIVER_H

#include "type.h"
#include <string.h>

#ifdef __cplusplus
extern "C"
{
#endif

/*---------------- ú꿪أɸMCUͻģʽʹѡ     --------------------*/
//#define HDSC_HC32L13x			1				//13xϵ
//#define HDSC_HC32L196			(!HDSC_HC32L13x)//196ϵ

#define BLE_CENTRAL_SLAVE_MOD	0				//ǷΪģʽ֧֣0ӻ1ӻ

/*------------------------------------*/
#define BLE_POW_PORT			(GpioPortE)		//Դ
#define BLE_POW_PIN				(GpioPin4)

#define BLE_CON_PORT			(GpioPortA)		//״ָ̬ʾ
#define BLE_CON_PIN				(GpioPin4)
#define BLE_CON_IRQ				PORTA_IRQn
#define BLE_CON_PRIORITY		IrqLevel2		//жȼ

#define BLE_LOWPOWER_PORT		(GpioPortA)		//
#define BLE_LOWPOWER_PIN		(GpioPin2)

#define BLE_RXPORT_IRQ			PORTA_IRQn
#define BLE_RXPORT_PRIORITY		IrqLevel2		//жȼ

#define BLE_CONorRX_IRQHandler		PORTA_IRQHandler
//#define BLE_TX_IRQHandler		PORTA_IRQHandler

#define BLE_CON_MSG					0xAA			//
#define BLE_DISCON_MSG				0xBB			//Ͽ
#define BLE_CON_NOMSG               0X00

#define CENTRAL_MODE			0xAA			//ģʽ
#define SLAVE_MODE				0xBB			//ӻģʽ
#define MODE_ERROR				0x00			//лʧ


#define SCAN_END				0x00			//ɨδʼ
#define SCAN_ING				0xBB			//ɨ
#define SACN_START_ORDER		0xAA			//ɨ
#define SACN_STOP_ORDER			0xBB			//ֹͣɨ
#define SCAN_START			0xCC				//ʼɨ

#define CON_START_ORDER			0xAA			//
#define CON_STOP_ORDER			0xBB			//Ͽ
#define CON_END					0xAA			//ӽδʼ
#define CON_ING					0xBB			//
#define CON_START				0xCC			//ʼ

#define CHK_KEY_WORD			0xAA			//ѯؼ
#define SET_KEY_WORD			0xBB			//޸Ĺؼ
#define CLR_KEY_WORD			0xCC			//ȡؼ

#define CHK_WHITE_LIST			0xAA			//ѯ
#define SET_WHITE_LIST			0xBB			//޸İ
#define CLR_WHITE_LIST			0xCC			//ȡ

#define CHK_NAME_MAC			0xAA			//ѯƼMAC
#define SET_NAME_MAC			0xBB			//޸ƼMAC

#define CHK_BLE_SEC				0xAA			//ѯ
#define SET_BLE_SEC				0xBB			//
#define CLR_BLE_SEC				0xCC			//ȡ

#define CHK_BLE_PIN				0xAA			//ѯ
#define SET_BLE_PIN				0xBB			//

//
#define BLE_TASK_FAIL               0xA8
#define BLE_TASK_SUCCESS            0xA9
#define BLE_TASK_INIT               0xB0

#define BLE_NAME_MAX_LEN		12				//Ƶ󳤶

//ʼ״̬״̬BLE
enum BLE_MAIN_STA
{
	S_BLE_IDLE = 0				,
	S_BLE_MAIN_INIT				,
	S_BLE_MAIN_CENTRAL_SWITCH	,
	S_BLE_MAIN_SCAN				,
	S_BLE_MAIN_CONNECT			,
	S_BLE_MAIN_NAME_MAC			,
	S_BLE_MAIN_ADV_DATA			,
	S_BLE_MAIN_ADV_PARAM		,
	S_BLE_MAIN_KEY_WORD			,
	S_BLE_MAIN_WHITE_LIST		,
	S_BLE_MAIN_CHK_STATUS		,
	S_BLE_MAIN_SEC_PIN			,
};

enum BLEINIT_STA
{
	S_BLEINIT_POWER_ON = 1		,	//ģ͵
	S_BLEINIT_POWER_WAIT		,
	S_BLEINIT_POWER_DW			,	//ʼϵ縴λ
	S_BLEINIT_POWER_DW_R		,
	S_BLEINIT_ATS				,	//ͳʼATָ
	S_BLEINIT_ADV0_CTL			,	//رչ㲥
	S_BLEINIT_VER				,	//ѯ汾
	S_BLEINIT_NAME				,	//ѯ㲥
	S_BLEINIT_NAME_SET			,	//ù㲥
	S_BLEINIT_MAC				,	//ѯģַ
	S_BLEINIT_MAC_SET			,	//ģַ
	S_BLEINIT_MAC_SAVE			,	//MAC
	S_BLEINIT_MAC_RESET			,	//MAC踴λ
	S_BLEINIT_TXPOW				,	//ѯ书
	S_BLEINIT_TXPOW_SET			,	//÷书
	S_BLEINIT_ADVPERIOD			,	//ѯ㲥ʱ
	S_BLEINIT_ADVPERIOD_SET		,	//ù㲥ʱ
	S_BLEINIT_CONPERIOD			,	//ѯ㲥ʱ
	S_BLEINIT_CONPERIOD_SET		,	//ù㲥ʱ
	S_BLEINIT_ADVMFID_SET		,	//ù㲥
	S_BLEINIT_ADV_CTL			,	//򿪹㲥
	S_BLEINIT_END
};

#if BLE_CENTRAL_SLAVE_MOD
//BLEģʽл״̬
enum BLEMODESWITCH_STA
{
//	S_BLE_SWITCH_IDLE = 0		,  
	S_BLE_SWITCH_CENTRAL = 1	,  	//ģʽ
	S_BLE_SWITCH_CENTRAL_CHK	,	//Ȳѯ״̬
	S_BLE_SWITCH_CENTRAL_DISCON	,	//Ͽ
	S_BLE_SWITCH_ADV0			,	//ֹͣ㲥
	S_BLE_SWITCH_STATUS			,	//ѯǰģʽ
	S_BLE_SWITCH_SET_CENTRAL	,	//лģʽ	
	S_BLE_SWITCH_SLAVE			,
	S_BLE_SWITCH_SLAVE_CHK		,	//Ȳѯ״̬
	S_BLE_SWITCH_SLAVE_DISCON	,	//Ͽ
	S_BLE_SWITCH_STATUS_SLAVE	,	
	S_BLE_SWITCH_SET_SLAVE		,	//лӻģʽ	
	S_BLE_SWITCH_ADV1			,	//㲥
};

//BLEʼɨ״̬
enum BLESCAN_STA
{
//	S_BLE_SCAN_IDLE = 0			,
	S_BLE_SCAN_START = 1		,
	S_BLE_SCAN_DISCON			,	//Ͽ
	S_BLE_SCAN_ING				,	//ɨ
	S_BLE_SCAN_OVERTIME			,	//ɨ賬ʱ
	S_BLE_SCAN_STOP				,
	S_BLE_SCAN_END				,
	S_BLE_SCAN_END_OVERTIME		,
};

//BLEMAC״̬
enum BLEWHITELIST_STA
{
	S_BLE_WHITE_LIST = 1		,	//޸İ
	S_BLE_WHITE_LIST_R			,
	S_BLE_WHITE_LIST_CLR		,	//ȡ
	S_BLE_WHITE_LIST_CLR_R		,
	S_BLE_WHITE_LIST_CHK		,	//
	S_BLE_WHITE_LIST_CHK_R		,
	S_BLE_WHITE_LIST_SAVE		,	//
};

#endif
//BLE״̬
enum BLECON_STA
{
	S_BLE_CON_START = 1			,
	S_BLE_CON_STATE_CHEK		,
	S_BLE_CON_DISCON			,	//Ͽ
	S_BLE_CON_DISCON_WAIT		,	//Ͽʱ
	S_BLE_CON_CLRBNDE			,	
	S_BLE_CON_RECON				,	//¸MAC
	S_BLE_CON_RECON_R			,
	S_BLE_CON_RECON_XIAODOU		,
	S_BLE_CON_STOP				,	//Ͽ
	S_BLE_CON_END				,
};

//BLE޸ƼMAC״̬
enum BLECHANGEMAC_STA
{
	S_BLE_MAC_SET_START = 1		,
	S_BLE_MAC_DISCON			,	//Ͽ
	S_BLE_MAC_ADV0				,	//ֹͣ㲥
	S_BLE_MAC_NAME				,	//޸
	S_BLE_MAC_MAC				,	//޸MAC
	S_BLE_MAC_SAVE				,	//޸MACҪ
	S_BLE_MAC_RESET				,	//޸ɺλ
	S_BLE_MAC_ADV1				,
	S_BLE_MAC_CHK_START			,
	S_BLE_MAC_NAME_CHK			,
	S_BLE_MAC_MAC_CHK			,
};

//BLE¹㲥״̬
enum BLEUPDATEADVDATA_STA
{
	S_BLE_UPDATE_ADV_START = 1	,
	S_BLE_UPDATE_ADV			,	//¹㲥
	S_BLE_UPDATE_ADV_RD_MAC		,
};

//BLE¹㲥״̬
enum BLECHANGEADVPARA_STA
{
	S_BLE_CHANGE_ADV_START = 1	,
	S_BLE_CHANGE_ADV0			,	//ֹͣ㲥
	S_BLE_CHANGE_ADV_PARAM		,	//޸Ĺ㲥
	S_BLE_CHANGE_CON_PARAM		,	//޸Ӽ
	S_BLE_CHANGE_TX_POWER		,	//޸ķ书
	S_BLE_CHANGE_SCAN_TIMES		,	//޸ɨ
	S_BLE_CHANGE_SAVE			,	//޸ɺ󱣴
	S_BLE_CHANGE_ADV1			,	//㲥
};

//BLE¹ؼ״̬
enum BLECHANGEKEYWORD_STA
{
	S_BLE_SET_KEY_WORD = 1		,	//޸Ĺؼ
	S_BLE_SET_KEY_WORD_R		,
	S_BLE_CHK_KEY_WORD			,	//ѯؼ
	S_BLE_CHK_KEY_WORD_R		,
	S_BLE_CLEAR_KEY_WORD		,	//ȡؼ
	S_BLE_CLEAR_KEY_WORD_R		,
	S_BLE_KEY_WORD_SAVE			,	//
};

//BLEѯģʽ״̬
enum BLECHKSTATUS_STA
{
	S_BLE_CHK_STATUS = 1		,	//ѯģʽ״̬
	S_BLE_CHK_STATUS_R			,
};

//BLEѯü״̬
enum BLESEC_STA
{
	S_BLE_CHK_SEC = 1		,	//ѯSEC
	S_BLE_CHK_SEC_R			,
	S_BLE_CHK_PIN			,	//ѯPIN
	S_BLE_SET_SEC_ADV0		,
	S_BLE_SET_SEC_ADV0_R	,
	S_BLE_SET_PIN			,	//PIN
	S_BLE_SET_PIN_R			,
	S_BLE_SET_SEC			,	//SEC
	S_BLE_SET_SEC_R			,
	
	S_BLE_SET_SEC_ADV1		,
	S_BLE_CLR_SEC			,	//ȡ
	S_BLE_CLR_SEC_R			,
	S_BLE_SEC_RESET			,
	S_BLE_SEC_SAVE			,	//
};


//ATָͨ״̬״̬״̬
typedef enum{
//	AT_REQUEST_IDLE = 0			,  
	BLE_AT_REQUEST_SEND = 1			,   	
	BLE_AT_REQUEST_CHECK			,
	BLE_AT_REQUEST_WT				,
}BLE_TYP_STATE_AT_REQUEST;


//ģATָ
typedef enum {
	AT_CODE_AT = 0				,	//AT
	AT_CODE_VER_CHK				,	//汾
	AT_CODE_NAME_CHK			,   //㲥Ʋѯ
	AT_CODE_NAME				,	//㲥
	AT_CODE_MAC_CHK				,	//ѯMAC
	AT_CODE_MAC					,	//MAC
	AT_CODE_TXPOWER_CHK			,	//书ʲѯ
	AT_CODE_TXPOWER				,	//书
	AT_CODE_ADVPARAM_CHK		,	//㲥ѯ
	AT_CODE_ADVPARAM			,	//㲥
	AT_CODE_CONPARAM_CHK		,	//Ӽѯ
	AT_CODE_CONPARAM			,	//Ӽ
	AT_CODE_ADVMFID				,	//㲥
	AT_CODE_ADV0				,	//رչ㲥
	AT_CODE_ADV1				,	//򿪹㲥
	AT_CODE_DISCON				,	//Ͽ
	AT_CODE_SLAVE				,	//Ϊӻģʽ
#if BLE_CENTRAL_SLAVE_MOD
    AT_CODE_CENTRAL				,	//Ϊģʽ
	AT_CODE_SCAN				,	//ɨΧ豸
	AT_CODE_CONNECT				,	//ָ
	AT_CODE_STOP_SCAN			,	//ֹͣɨ
	AT_CODE_WHITE_LIST_SET		,	//MAC
	AT_CODE_WHITE_LIST_CLR		,	//ȡMAC
	AT_CODE_WHITE_LIST_CHK		,	//ѯMAC
#endif
	AT_CODE_SCAN_TIMES			,	//ɨ
	AT_CODE_KEY_CHK				,	//ѯؼ
	AT_CODE_KEY_SET				,	//޸Ĺؼ
	AT_CODE_KEY_CLR				,	//ȡؼ
	AT_CODE_RESET				,	//λ
	AT_CODE_SAVE				,	//
	AT_CODE_STATUS				,	//ѯģʽ״̬
	AT_CODE_SEC_CHK				,	//ѯ
	AT_CODE_SEC_SET				,	//
	AT_CODE_SEC_CLR				,	//ȡ
	AT_CODE_PIN_CHK				,	//ѯ
	AT_CODE_PIN					,	//
	AT_CODE_CLRBNDE				,	//ʱǰ跢
	
	AT_CODE_ALL
} BLE_TYP_AT_CMDCODE;

//ATָȴӦʱ
typedef enum {				//ʹ100msʱ
	BLE_WT_0S = 0,
	BLE_WT_halfS = 5,
	BLE_WT_1S = 10,
	BLE_WT_2S = 20,
	BLE_WT_5S = 50,
} BLE_TYP_AT_WAIT_TIME;

//ATָԴ
typedef enum {
	BLE_RETRY_0 = 0,
	BLE_RETRY_1,
	BLE_RETRY_2,
	BLE_RETRY_3,
	BLE_RETRY_4,
	BLE_RETRY_5,
	BLE_RETRY_15 = 15,
} BLE_TYP_AT_RETRY_COUNT;

//ATָ״ִ̬н
typedef enum {
	ResultBusy = 0,
	ResultOk,
	ResultError,
	ResultFail
} BLE_TYP_RESULT_CODE;

//״̬
typedef enum {
	BleNoCon = 0,
	BleSlaveCon,
	BleMasterCon
} TYP_CON_STATUS;

//״̬״̬
typedef enum {
	BlePowerOk = 0,
	BlePowerWrong,   //,ǿƶϵ״̬
	BlePowerFactory  //ģʽڼϵ״̬
} TYP_POWER_STATUS;
//******************************* ṹ嶨*************************************

typedef struct 
{
	unsigned char AtCode;		//ָ
	unsigned char CaseAtNum;	//Ӧ
	unsigned char ErrorLimit;	//Գ
//	unsigned char ExpectLen;	//ڴӦݳ
	char* pAtCmdStr;			//ָָ
//	char* pExpectData;			//ڴӦָ
	unsigned short int WaitTime;//ȴӦʱ䣬ms
} BLE_STRUCT_AT_CMD, *P_BLE_STRUCT_AT_CMD; 

typedef union
{
	struct
	{
		u8 at_err:1			;	//ѯAT쳣
		u8 ver_err:1		;	//ѯ汾쳣
		u8 name_chk_err:1	;	//ѯ쳣
		u8 name_set_err:1	;	//쳣
		u8 mac_chk_err:1	;	//ѯMAC쳣
		u8 mac_set_err:1	;	//MAC쳣
		
	};
	mtype32_ err_byte;
} BLE_STATE_ERR;	//״ָ̬ʾ

typedef struct
{
    u8 Ble_cur_mode; 			//ǰģʽ
    u8 Ble_scan_state; 			//ǰɨ״̬ɨδʼɨСɨ
	u8 Ble_con_state;			//ǰ״̬
	u8 Ble_power_flag;			//ǰĹ״̬
	u8 Ble_con_MAC[12];			//ʱMAC
	u8 Ble_adv_data[13];		//㲥
	u8 Ble_key_word_len;		//ؼֳ
	u8 Ble_key_word[12];		//ؼ
	u8 Ble_white_list[15][6];	//MAC
	u8 Ble_softverson[2];		//汾
	u8 Ble_name[12];			//
	u8 Ble_mac[6];				//MAC
	u8 Ble_cur_sec;				//ǰļ״̬
	u8 Ble_cur_pin[3];			//ǰʹõ룬벻λ

} BLE_WORK_STATE;

//******************************* ⲿ***************************************


//******************************* ⲿӿں***********************************
void BleInit(void);
void BleMainMachine(void);
u8 BleIfIdle(void);
u8 BleIfSleep(void);
void BlePreSleep(void);
void BleWakeSleep(void);

void BlePowerOff(void);
void BlePowerOn(void) ;
u8 BleIfPowerOn(void);
void BleForcePowerOff(TYP_POWER_STATUS data);

u8 format_ascii2hex(u8 *dest, u8 *sour, u8 sourlen);
//ӿ
void BleStartInitTask(void);				//ʼ
void BleCentralSwitchTask(u8 switch_type);	//л
u8 BleGetCurMode(void);						//ȡǰģʽ


u8 BleConMacTask(u8 con_oeder,u8 *con_mac);	//ӻϿ
u8 BleGetCurConState(void);		//ѯǰ״̬
void BleNameMacTask(u8 opr_type,u8* name_src);//޸ƼMAC
u8 BleUpdataAdvDataTask(u8* snd_data);		//¹㲥
void BleChangeAdvParaTask(void);			//
void BleKeyWordTask(u8 type,u8* key_word,u8 key_len);//ؼ
u8 BleGetCurKeyWord(u8* key_addr);			//ѯǰؼ
void BleChkStatusTask(void);				//ѯǰģʽ״̬
u8 BleSecChkOrSetTask(u8 sec_type);			//ѯáȡ
u8 BleChkCurSecState(u8 **cur_pin);			//ȡǰļ״̬PIN

#if BLE_CENTRAL_SLAVE_MOD
void BleMacWhiteListTask(u8 type,u8* list_addr);//MAC
u8 BleScanTask(u8 scan_order);				//رɨ
u8 BleGetCurScanState(void);				//ȡǰɨ״̬
#endif

void BleGetFirmVerson(u8* verson_addr);		//ȡ汾
void BleGetCurMacAddr(u8 *cur_mac);			//ȡǰMAC
void Ble_IODeInit(void);
void BleClearResetCount(void);
TYP_POWER_STATUS BleGetPowerState(void);
//u8 BleCheckConInitMsg(void);
//u8 BleClrConInitMsg(void);
//u8 BleCheckTxInitMsg(void);
//u8 BleClrTxInitMsg(void);

//#pragma pack()

#ifdef __cplusplus
}
#endif

#endif	



