/************************************************************************************
 * @Copyright (c)    :(C)2022, Qindao ieslab Co., Ltd
 * @FileName   	     :hdsc_nb_driver.c
 * @Author           :QDIES PLATFORM TEAM
 * @Version          :V1.0
 * @Date             :2022-02
 * @Description      : l660
 ************************************************************************************/
#include "sys_config.h"
#ifdef MODULE_BLE_USED
#include "ble14531_driver.h"
#include "ble14531_uart_driver.h"
#include "UWater_uart_driver.h"
#include "stdio.h"
#include <time.h>
#include "sys_processor.h"
#include "UWater_timer1uS_driver.h"
//#include "sys_processor.h"
#include "UWater_gpio_driver.h"
//#include "triple_pulse_driver.h"
//#include "adc_driver.h"
#include "UWater_DebugPrint.h"
#include "SOE.h"
#include "UWater_clktrim_driver.h"

#ifdef	__cplusplus
extern "C"
{
#endif

/********************************************************************/
//ATָ
const BLE_STRUCT_AT_CMD AtCmdBuf[]={
/*****ʼָ********************/
	{AT_CODE_AT, BLE_cst_AT_AT, BLE_RETRY_2,"AT?", BLE_WT_1S},									//AT
	{AT_CODE_VER_CHK, BLE_cst_AT_QUERY, BLE_RETRY_1, "AT+VER?", BLE_WT_1S},						//ѯ汾
	{AT_CODE_NAME_CHK, BLE_cst_AT_QUERY, BLE_RETRY_1, "AT+NAME?", BLE_WT_2S},   				//ѯ㲥
	{AT_CODE_NAME, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+NAME=JC", BLE_WT_1S},					//ù㲥
	{AT_CODE_MAC_CHK, BLE_cst_AT_QUERY, BLE_RETRY_1, "AT+MAC?", BLE_WT_1S},						//ѯMACַ
	{AT_CODE_MAC, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+MAC=", BLE_WT_1S},						//MACַ
	{AT_CODE_TXPOWER_CHK, BLE_cst_AT_QUERY, BLE_RETRY_0, "AT+TX_POWER?", BLE_WT_1S},			//ѯ书
	{AT_CODE_TXPOWER, BLE_cst_AT_OK_ERROR, BLE_RETRY_0, "AT+TX_POWER=", BLE_WT_1S},				//÷书
	{AT_CODE_ADVPARAM_CHK, BLE_cst_AT_QUERY, BLE_RETRY_0,"AT+ADV_PARAM?", BLE_WT_1S},			//ѯ㲥
	{AT_CODE_ADVPARAM, BLE_cst_AT_OK_ERROR, BLE_RETRY_0,"AT+ADV_PARAM=", BLE_WT_1S},			//ù㲥
	{AT_CODE_CONPARAM_CHK, BLE_cst_AT_QUERY, BLE_RETRY_0, "AT+CON_PARAM?", BLE_WT_1S},			//ѯӼ
	{AT_CODE_CONPARAM, BLE_cst_AT_OK_ERROR, BLE_RETRY_0,"AT+CON_PARAM=", BLE_WT_1S},			//Ӽ
	{AT_CODE_ADVMFID, BLE_cst_AT_OK_ERROR, BLE_RETRY_2,"ADV", BLE_WT_1S},						//ù㲥
	{AT_CODE_ADV1, BLE_cst_AT_OK_ERROR, BLE_RETRY_2, "AT+ADV=1", BLE_WT_1S},					//򿪹㲥
	{AT_CODE_ADV0, BLE_cst_AT_OK_ERROR, BLE_RETRY_2, "AT+ADV=0", BLE_WT_1S},					//رչ㲥
	{AT_CODE_DISCON, BLE_cst_AT_OK_ERROR, BLE_RETRY_2, "AT+DISCONNECT", BLE_WT_1S},				//Ͽ
	{AT_CODE_SLAVE, BLE_cst_AT_OK_ERROR, BLE_RETRY_2, "AT+PER", BLE_WT_2S},						//Ϊӻģʽ
#if BLE_CENTRAL_SLAVE_MOD
    {AT_CODE_CENTRAL, BLE_cst_AT_OK_ERROR, BLE_RETRY_2, "AT+CENTRAL", BLE_WT_1S},				//Ϊģʽ
	{AT_CODE_SCAN, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+SCAN", BLE_WT_2S},						//ɨΧ豸
	{AT_CODE_CONNECT, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+CONNECT=", BLE_WT_2S},				//ָӻ
	{AT_CODE_STOP_SCAN, BLE_cst_AT_OK_ERROR, BLE_RETRY_1,"AT+STOPSCAN", BLE_WT_2S},				//ֹͣɨ
	{AT_CODE_WHITE_LIST_SET, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+WHITEMAC=", BLE_WT_2S},		//MAC
	{AT_CODE_WHITE_LIST_CLR, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+CLEARMAC", BLE_WT_2S},		//ȡMAC
	{AT_CODE_WHITE_LIST_CHK, BLE_cst_AT_QUERY, BLE_RETRY_1, "AT+WHITEMAC?", BLE_WT_2S},			//ѯMAC
#endif
	{AT_CODE_SCAN_TIMES, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+SCAN_CNT=", BLE_WT_2S},			//ɨ	
	{AT_CODE_KEY_CHK, BLE_cst_AT_QUERY, BLE_RETRY_1, "AT+CMP_NAME?", BLE_WT_2S},				//ѯؼ
	{AT_CODE_KEY_SET, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+CMP_NAME=", BLE_WT_2S},				//޸Ĺؼ
	{AT_CODE_KEY_CLR, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+EXIT_CMP_NAME", BLE_WT_2S},			//ȡؼ
	{AT_CODE_RESET, BLE_cst_AT_OK_ERROR, BLE_RETRY_0, "AT+RESET", BLE_WT_0S},					//λ
	{AT_CODE_SAVE, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+SAVE", BLE_WT_1S},						//
	{AT_CODE_STATUS, BLE_cst_AT_QUERY, BLE_RETRY_1, "AT+STATUS?", BLE_WT_2S},					//ѯģʽ״̬
	{AT_CODE_SEC_CHK, BLE_cst_AT_QUERY, BLE_RETRY_1, "AT+SEC?", BLE_WT_2S},						//ѯ
	{AT_CODE_SEC_SET, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+SEC=1", BLE_WT_2S},					//
	{AT_CODE_SEC_CLR, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+SEC=3", BLE_WT_2S},					//ȡ
	{AT_CODE_PIN_CHK, BLE_cst_AT_QUERY, BLE_RETRY_1, "AT+PIN?", BLE_WT_2S},						//ѯ
	{AT_CODE_PIN, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+PIN=", BLE_WT_2S},						//
	{AT_CODE_CLRBNDE, BLE_cst_AT_OK_ERROR, BLE_RETRY_1, "AT+CLRBNDE", BLE_WT_1S},				//ʱǰ跢
};
/********************************************************************/
BLE_STRUCT_AT_CMD cur_atcmdbuf;				//Ҫ͵ATָ
const BLE_STRUCT_AT_CMD *p_cur_atcmdbuf;

//״̬(״̬е״̬)
u8 s_BLE_main_state = S_BLE_IDLE;			//״̬״̬
u8 s_BLE_init_state = S_BLE_IDLE;				//ϵʼ״̬״̬
u8 s_BLE_conmgr_state = S_BLE_IDLE;				//ӹ״̬
u8 s_BLE_chk_status_state =  S_BLE_IDLE;		//ѯģʽ״̬
u8 s_BLE_sec_status_state = S_BLE_IDLE;			//ѯü
#if BLE_CENTRAL_SLAVE_MOD
u8 s_BLE_mode_switch_state = S_BLE_IDLE;		//ģʽл״̬
u8 s_BLE_scan_state = S_BLE_IDLE;				//ģʽɨ״̬
u8 s_BLE_white_list_state =  S_BLE_IDLE;		//MAC
#endif

u8 s_BLE_change_mac_state = S_BLE_IDLE;			//ƼMAC״̬
u8 s_BLE_update_adv_data_state = S_BLE_IDLE;	//㲥
u8 s_BLE_change_adv_para_state =  S_BLE_IDLE;	//㲥
u8 s_BLE_change_key_word_state =  S_BLE_IDLE;	//ؼ
u8 s_BLE_at_requeset_state = S_BLE_IDLE;		//AT״̬

//const u8 ble_key_word[] = {'J','C','B','T','-'};	//ĬϹؼ
const u8 ble_key_word[] = {'J','C'};				//ĬϹؼ
char ble_default_pin[] = {'3','3','7','8','0','0'};	//Ĭ

u8 g_ble_task_flag = BLE_TASK_INIT;			//״̬н
u8 g_ble_at_requestErrorCount;				//ATָԴ
u8 ble_power_flag = FALSE;					//ģǷе


char BLE_AT_BUF[BLE_AT_UP_BUF_SIZE];		//ATָͻ
u8 g_ble_at_rcv_len;						//ATָݳ
u8 *p_ble_at_rcv_data;						//ATָݵĵַ
u8 ble_reset_flg;							//ʼʧܸλ
BLE_STATE_ERR ble_state_error;
BLE_WORK_STATE ble_work_stat = {0};			//ڼĲ
u8 ble_temp_arr[12];						//ʱ
u8 ble_temp_len = 0;						//ʱ
u8 ble_white_MAC_set[6];					//ɨ
mtype16_ ble_temp_data;						//ʱ
u8 ble_con_msg = 0;				//ϿӵϢ
//u8 ble_tx_msg = 0;
u8 ble_reset_count=0;
TYP_POWER_STATUS flag_ble_force_power = BlePowerOk; //ǿƶϵ־ 
/*****************************ڲ״̬***********************************/
void BleInitMachine(void);
void BleConMgrMachine(void);
u8 CheckMetAddrIfInit(void);
///*****************************ڲӿ****************************************/

/***************************************************************************
 * @fun_name     void AT_Common_Requeset_Proc()
 * @brief        ATָͨòѯ
 * @param[in] 	 None
 * @param[out] 	 None
 * @retval     	 None
 * @other 
 ***************************************************************************/
int getAtCmdIndex(BLE_TYP_AT_CMDCODE atCode)
{
    for(int i = 0; i < AT_CODE_ALL; i++)
	{
	    if(AtCmdBuf[i].AtCode == atCode)
		{
		    return i;
		}
	}
	return 0;
}


/***************************************************************************
* @fun_name		u8 asc16num(char asc16)
* @brief		ַתΪ16
* @param[in]	asc16ַʾ16
* @param[out]	None
* @retval		ת
* @other		None
***************************************************************************/
u8 asc16_num(char asc16)
{
	u8 tempbyte=0;
	if(asc16 > 47 && asc16 < 58)
	{
		tempbyte = asc16 - 48;
	}
	else if(asc16 > 64 && asc16 < 71)
	{
		tempbyte = asc16 - 55;
	}
	else if(asc16 > 96 && asc16 < 103)
	{
		tempbyte = asc16 - 87;
	}
	else
	{
		tempbyte = 0;
	}
	return tempbyte;
}

/***************************************************************************
* @fun_name		u8 format_ascii2hex(u8 *dest, u8 *sour, u8 sourlen)
* @brief		ַתΪ16
* @param[in]	*sourַʾ16ݣdatalenַȣΪż\0
* @param[out]	*destת
* @retval		תĳ
* @other		None
***************************************************************************/
u8 format_ascii2hex(u8 *dest, u8 *sour, u8 sourlen)
{
	u8 i;
	u8 destlen = sourlen / 2;
	for(i = 0; i < destlen; i++)
	{
		dest[i] = asc16_num(sour[i * 2]) << 4;
		dest[i] += asc16_num(sour[i * 2 + 1]);
	}
	if(sourlen % 2)
	{
		dest[i] = asc16_num(sour[i * 2]) << 4;
		dest[i] &= 0xF0; 
		destlen++;
	}
	return destlen;
}


u8 IntToHexChar(u8 c)
{
	if (c > 9)
		return (c + 0x37);
	else
		return (c + 0x30);
}
/***************************************************************************
* @fun_name		u8 format_Hex2ascii(u8 *dest, u8 *sour, u8 sourlen)
* @brief		ʮתΪַ
* @param[in]	*sour16ݣdatalen16ݳ
* @param[out]	*destת
* @retval		תĳ
* @other		None
***************************************************************************/
void format_Hex2ascii(u8 *dest, u8 *sour, u8 sourlen)
{
	u8 i = 0;
	u8 temp = 0;
	for (i=0; i<sourlen; i++) 
	{
		temp = sour[i]&0xf0;
		dest[2*i] = IntToHexChar(temp >> 4);
		temp = sour[i]&0x0f;
		dest[2*i+1] = IntToHexChar(temp);
	}
}

/***************************************************************************
* @fun_name		u8 format_Dec2ascii(u8 *dest, u16 src)
* @brief		ʮתΪַ
* @param[in]	src16
* @param[out]	*destת
* @retval		תĳ
* @other		None
***************************************************************************/
u8 format_Dec2ascii(u8 *dest, u16 src)
{
	u8 destlen = 0;
	u8 temp_flag = 0;
	u16 temp_i,temp_data,temp_rcv_data;
	
	temp_rcv_data = src;
	if(!temp_rcv_data)		//Ϊ0
	{
		dest[destlen++] =0x30;
	}
	else
	{
		for(temp_i = 10000; temp_i > 0; temp_i /= 10)
		{
			temp_data = temp_rcv_data / temp_i;
			if(temp_data || temp_flag)
			{
				dest[destlen++] = temp_data + 0x30;
				temp_rcv_data -= (temp_data * temp_i);
				temp_flag = 1;
			}
		}
	}
	return destlen;
}

//********************  ӿ ******************************//

/***************************************************************************
* @fun_name     void Ble_IOInit(void)
* @brief        ģ鹩IOģ鸴λԴPSMųʼ
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
***************************************************************************/
void Ble_IOInit(void)
{
	stc_gpio_cfg_t stcGpioCfg;
	DDL_ZERO_STRUCT(stcGpioCfg);
	
    stcGpioCfg.enDir = GpioDirOut;		///< ˿ڷ
    stcGpioCfg.enDrv = GpioDrvL;		///< ˿->
    stcGpioCfg.enPu = GpioPuDisable;	///< ˿->
    stcGpioCfg.enPd = GpioPdDisable;
    stcGpioCfg.enOD = GpioOdDisable;	///< ˿ڿ©
    stcGpioCfg.enCtrlMode = GpioAHB;	///< ˿/ֵĴ߿ģʽ->AHB
	stcGpioCfg.bOutputVal = TRUE;

	Gpio_Init(BLE_POW_PORT, BLE_POW_PIN, &stcGpioCfg);				//ƶ˿
	BlePowerOff();														//ϵ
	
	stcGpioCfg.bOutputVal = FALSE;
	Gpio_Init(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN, &stcGpioCfg);	//Ѷ˿
	Gpio_ClrIO(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN);					//ߵƽģ
	
	stcGpioCfg.enDir = GpioDirIn;										///< ˿ڷã
	Gpio_Init(BLE_CON_PORT, BLE_CON_PIN, &stcGpioCfg);   			//ָʾ˿
	Gpio_EnableIrq(BLE_CON_PORT, BLE_CON_PIN, GpioIrqRising);			//жϣָʾӽ
	Gpio_EnableIrq(BLE_CON_PORT, BLE_CON_PIN, GpioIrqFalling);			//½жϣָʾӶϿ
	EnableNvic(BLE_CON_IRQ, BLE_CON_PRIORITY, TRUE);		//
}

/***************************************************************************
* @fun_name     void Ble_IODeInit(void)
* @brief        ģ鹩IOģ鸴λԴPSMųʼ
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
***************************************************************************/
void Ble_IODeInit(void)
{
	stc_gpio_cfg_t stcGpioCfg;
    DDL_ZERO_STRUCT(stcGpioCfg);
    stcGpioCfg.enDir = GpioDirOut;		///< ˿ڷ
    stcGpioCfg.enDrv = GpioDrvL;		///< ˿->
//    stcGpioCfg.enPu = GpioPuDisable;	///< ˿->
//    stcGpioCfg.enPd = GpioPdDisable;
//    stcGpioCfg.enOD = GpioOdDisable;	///< ˿ڿ©
    stcGpioCfg.enCtrlMode = GpioAHB;	///< ˿/ֵĴ߿ģʽ->AHB

	Gpio_Init(BLE_POW_PORT, BLE_POW_PIN, &stcGpioCfg);				//ƶ˿
	BlePowerOff();						//ϵ
	
	Gpio_Init(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN, &stcGpioCfg);	//Ѷ˿,ߵƽģ
	
	Gpio_Init(BLE_TX_PORT, BLE_TX_PIN, &stcGpioCfg);			//TXҲΪ

	Gpio_Init(BLE_RX_PORT, BLE_RX_PIN, &stcGpioCfg);			//RXҲΪ
	
	stcGpioCfg.enDir = GpioDirIn;										///< ˿ڷã
	stcGpioCfg.enPd = GpioPdEnable;
	Gpio_Init(BLE_CON_PORT, BLE_CON_PIN, &stcGpioCfg);   			//ָʾ˿
	Gpio_DisableIrq(BLE_CON_PORT, BLE_CON_PIN, GpioIrqRising);			//жϣָʾӽ
	Gpio_DisableIrq(BLE_CON_PORT, BLE_CON_PIN, GpioIrqFalling);			//½жϣָʾӶϿ
	EnableNvic(BLE_CON_IRQ, BLE_CON_PRIORITY, FALSE);		//
}
/***************************************************************************
 * @fun_name    void BlePowerOff(void)
 * @brief        ϵ紦
 * @param[in] 	 None
 * @param[out] 	 None
 * @retval     	 None
 * @other        None
 ***************************************************************************/
void BlePowerOff(void)
{
	Gpio_ClrIO(BLE_POW_PORT, BLE_POW_PIN);				//
	Gpio_ClrIO(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN);	//
	ble_work_stat.Ble_power_flag = FALSE;				//¼Դ״̬
}
/***************************************************************************
 * @fun_name    void BlePowerOn(void) 
 * @brief        ϵ紦
 * @param[in] 	 None
 * @param[out] 	 None
 * @retval     	 None
 * @other        None
 ***************************************************************************/
void BlePowerOn(void)  
{
	Gpio_SetIO(BLE_POW_PORT, BLE_POW_PIN);				//
	ble_work_stat.Ble_power_flag = TRUE;				//¼Դ״̬
	Gpio_SetIO(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN);	//ֻ
}

/***************************************************************************
 * @fun_name    u8 BleIfPowerOn(void)
 * @brief        ѯǷϵ
 * @param[in] 	 None
 * @param[out] 	 None
 * @retval     	 None
 * @other        None
 ***************************************************************************/
u8 BleIfPowerOn(void)
{    
	return ble_work_stat.Ble_power_flag;    
}


/***************************************************************************
* @fun_name     BLE_TYP_RESULT_CODE AT_Requeset_Proc(const BLE_STRUCT_AT_CMD *atCmd, char* addBuf, int addLen)
* @brief        ԲͬATָд
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
***************************************************************************/
BLE_TYP_RESULT_CODE AT_Requeset_Proc(const BLE_STRUCT_AT_CMD *atCmd, char* addBuf, int addLen)
{
	switch(s_BLE_at_requeset_state)
	{
		case S_BLE_IDLE:
		{
			g_ble_at_requestErrorCount = 0;
			if(UartSendMachineIfIdle(BLE_UART_COM))
			{
				Set100msTimer(TIMER_100MS_BLE, 5);
				s_BLE_at_requeset_state = BLE_AT_REQUEST_SEND;
			}
		}
		break;
		case BLE_AT_REQUEST_SEND:		//ATָ
		{
			if((Check100msTimer(TIMER_100MS_BLE) == 0) && (TASK_IDLE == UartIfIdle(BLE_UART_COM)))
			{
				memset(BLE_AT_BUF, 0, sizeof(BLE_AT_BUF));
				int i = 0;
				int all_len = 0;
				int str_len = strlen(atCmd->pAtCmdStr);
				const char *p;
				p = atCmd->pAtCmdStr;
				for(i = 0; i < str_len; i++)
				{
					BLE_AT_BUF[i] = *p++;
					all_len++;
				}
				if(addLen)
				{
					for(i = 0; i < addLen; i++)
					{
						BLE_AT_BUF[str_len + i] = *addBuf++;
						all_len++;
					}
				}
				BLE_AT_BUF[all_len++] = '\r';
				BLE_AT_BUF[all_len++] = '\n';
				
				BleUartSend((u8*)BLE_AT_BUF, all_len, atCmd->CaseAtNum);//strlen(AT_BUF),ֻܷ͵0x00
				Set100msTimer(TIMER_100MS_BLE, atCmd->WaitTime);
				s_BLE_at_requeset_state = BLE_AT_REQUEST_CHECK;
			}
		}
		break;
		case BLE_AT_REQUEST_CHECK:		//ATָĽ
		{
			if (BleCheckAtAck() == BLE_UART_OK)//ȷӦ
            {
				s_BLE_at_requeset_state = S_BLE_IDLE;
				return ResultOk;
            }
            else if ((Check100msTimer(TIMER_100MS_BLE) == 0) || (BleCheckAtAck() == BLE_UART_ERROR)) //Ӧʱߴ
            {
                if (g_ble_at_requestErrorCount >= atCmd->ErrorLimit)
                {
					s_BLE_at_requeset_state = S_BLE_IDLE;
					return ResultFail;
                }
                else
                {
					g_ble_at_requestErrorCount++;
					if(BleCheckAtAck() == BLE_UART_ERROR)
					{
						Set100msTimer(TIMER_100MS_BLE, 2);
					}
					s_BLE_at_requeset_state = BLE_AT_REQUEST_SEND;
                }
            }
		}
		break;
		default:
		{
			s_BLE_at_requeset_state = S_BLE_IDLE;
			return ResultFail;
		}
	}
	return ResultBusy;
}

/***************************************************************************
 * @fun_name     void BleChkLowpowerState(void)
 * @brief        ѯLowPowerǸ߻͵ƽǵ͵ƽΪǴ߳δдڳʼ
 * @param[in] 	 None
 * @param[out] 	 None
 * @retval     	 None
 * @other        None
 ***************************************************************************/
void BleChkLowpowerState(void)
{
	if(Gpio_ReadOutputIO(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN))	//lowpowerΪߵƽ
	{
		Set5msTimer(TIMER_5MS_LOWPOWER,0);
	}
	else
	{
		Gpio_SetIO(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN);	//ֻ
		UartInit(BLE_UART_COM, BAUD38400, DATA_BIT_8, STOPBIT_1, UART_EVEN_PARITY, UART_LPUART_Disable);
		Set5msTimer(TIMER_5MS_LOWPOWER,10);
	}
}

/************************************************************************************************************************************
* 
*									ʼ
*
************************************************************************************************************************************/
/***************************************************************************
 * @fun_name     void BleInit(void)
 * @brief        BLEʼ
 * @param[in] 	 None
 * @param[out] 	 None
 * @retval     	 None
 * @other        None
 ***************************************************************************/
void BleInit(void)
{
	Ble_IOInit();
	ble_work_stat.Ble_scan_state = SCAN_END;
	ble_work_stat.Ble_cur_mode = SLAVE_MODE;
	ble_work_stat.Ble_con_state = CON_END;
	ble_work_stat.Ble_power_flag = FALSE;
}


/***************************************************************************
 * @fun_name     void BleInitMachine(void)
 * @brief        BLEʼ״̬
 * @param[in] 	 None
 * @param[out] 	 None
 * @retval     	 None
 * @other        None
 ***************************************************************************/
/*ģ˴ڵ*/
void NB_UartInitForGPIO(void)//debug
{
    stc_gpio_cfg_t stcGpioCfg;

	DDL_ZERO_STRUCT(stcGpioCfg);
    //PA0,PA1:Ϊ
    stcGpioCfg.enDir = GpioDirIn;    ///< ˿ڷ->
    stcGpioCfg.enDrv = GpioDrvL;     ///< ˿->
    stcGpioCfg.enPu = GpioPuDisable; ///< ˿->
    stcGpioCfg.enPd = GpioPdDisable;
    stcGpioCfg.enOD = GpioOdDisable; ///< ˿ڿ©->©ر
    stcGpioCfg.enCtrlMode = GpioAHB; ///< ˿/ֵĴ߿ģʽ->AHB
    Gpio_Init(GpioPortA, GpioPin0, &stcGpioCfg);	
    Gpio_Init(GpioPortA, GpioPin1, &stcGpioCfg);
}


void BleInitMachine(void) 
{
	static u8 init_cnt,init_i;
	static u8 init_flag = FALSE;
	switch (s_BLE_init_state)			//NBģ鹩
    {
		case S_BLE_IDLE:
		{
			break;
		}
		case S_BLEINIT_POWER_ON:
		{
			if(ClkTrimIfIdle()==TASK_IDLE)
			{
				if(ble_reset_count<Sys_data_object.P1.func_cfg_bytes[23])
				{
					ble_reset_count++;
					flag_ble_force_power=BlePowerOk;//ǿƶϵ־
					BleInit();
					UartInit(BLE_UART_COM, BAUD38400, DATA_BIT_8, STOPBIT_1, UART_EVEN_PARITY, UART_LPUART_Disable);			
					BlePowerOn();	//ģ鹩
					ble_reset_flg = 0;
					Set100msTimer(TIMER_100MS_BLE, 30);	//򿪵Դʱ3S,ȴϵȶ
					s_BLE_init_state = S_BLEINIT_POWER_WAIT; 
					//NB_UartInitForGPIO();////////////debug
				}
				else
				{
					g_ble_task_flag = BLE_TASK_FAIL;//ʧܺ,ǿƶϵ
					s_BLE_init_state = S_BLE_IDLE;
				}
			}
		}
		break;

		case S_BLEINIT_POWER_WAIT:
		{
			if (!Check100msTimer(TIMER_100MS_BLE))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_AT)];
				s_BLE_init_state = S_BLEINIT_ATS;
			}	
		}
		break;
		
		case S_BLEINIT_POWER_DW:
		{
			if (!Check100msTimer(TIMER_100MS_BLE))
			{
				ble_reset_flg++;
				BlePowerOff();
				Set100msTimer(TIMER_100MS_BLE, 20);
				s_BLE_init_state = S_BLEINIT_POWER_DW_R;
			}
		}
		break;
		case S_BLEINIT_POWER_DW_R:
		{
			if (!Check100msTimer(TIMER_100MS_BLE))
			{
				BlePowerOn();
				Set100msTimer(TIMER_100MS_BLE, 2);
				s_BLE_init_state = S_BLEINIT_POWER_WAIT;
			}
		}
		break;

		case S_BLEINIT_ATS:			//ATԴǷ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV0)];
					s_BLE_init_state = S_BLEINIT_ADV0_CTL;
					break;
				}
				case ResultFail:
				{
					if(ble_reset_flg)	//ѾλһΣǿƹػ
					{
						ble_reset_flg = 0;
						g_ble_task_flag = BLE_TASK_FAIL;//ʧܺ,ǿƶϵ
						s_BLE_init_state = S_BLE_IDLE;	//ϵ縴λATԲͨϵ
					}
					else //ʧܣִһθλ
					{
						UartInit(BLE_UART_COM, BAUD38400, DATA_BIT_8, STOPBIT_1, UART_EVEN_PARITY, UART_LPUART_Disable);
						s_BLE_init_state = S_BLEINIT_POWER_DW;
					}
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_ADV0_CTL:	//رչ㲥
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_VER_CHK)];
					s_BLE_init_state = S_BLEINIT_VER;
				}
				break;
				default:
					break;
			}
		}
		break;

		case S_BLEINIT_VER:			//ѯģ汾
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{					
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					if(g_ble_at_rcv_len > 12)
					{
						g_ble_at_rcv_len = 12;
					}
					if(('V' == p_ble_at_rcv_data[0]) && ('.' == p_ble_at_rcv_data[3]))
					{
						ble_work_stat.Ble_softverson[0] = ((p_ble_at_rcv_data[1] - 0x30) << 4) | (p_ble_at_rcv_data[2] - 0x30);		//¼汾
						ble_work_stat.Ble_softverson[1] = ((p_ble_at_rcv_data[4] - 0x30) << 4) | (p_ble_at_rcv_data[5] - 0x30);
					}
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_NAME_CHK)];
					memset(ble_work_stat.Ble_name,0,12);
					s_BLE_init_state = S_BLEINIT_NAME;
					break;
				}
				default:
					break;
			}
		}
		break;

		case S_BLEINIT_NAME:		//ѯ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					if(g_ble_at_rcv_len > BLE_NAME_MAX_LEN)		//Ʋ12ֽ
					{
						g_ble_at_rcv_len = BLE_NAME_MAX_LEN;
					}
					init_flag = TRUE;
					for(init_cnt = 0; init_cnt < sizeof(ble_key_word); init_cnt++)
					{
						if(p_ble_at_rcv_data[init_cnt] != ble_key_word[init_cnt])		//ƵĿʼǹؼ
						{
							init_flag = FALSE;
							break;
						}
					}
					if(TRUE == init_flag)
					{
						for(init_i = 0; init_cnt < g_ble_at_rcv_len; init_cnt++,init_i++)
						{
							ble_work_stat.Ble_name[init_i] = p_ble_at_rcv_data[init_cnt];	//ֻȡǹؼֲ
						}
					}
				case ResultError:
				case ResultFail:
				{					
					for(init_i = 0; init_i < 5; init_i++)
					{
						ble_temp_arr[init_i * 2] = (Sys_data_object.P1.met_addr[4 - init_i] >> 4) + 0x30;
						ble_temp_arr[init_i * 2 + 1] = (Sys_data_object.P1.met_addr[4 - init_i] & 0x0F) + 0x30;
					}
					init_flag = FALSE;
					for(init_i = 0; init_i < 10; init_i++)
					{
						if(ble_temp_arr[init_i] != ble_work_stat.Ble_name[init_i])
						{
							init_flag = TRUE;
							break;
						}
					}
					if(init_flag && CheckMetAddrIfInit())		//ַһ£ұַȫ0
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_NAME)];
						s_BLE_init_state = S_BLEINIT_NAME_SET;
					}
					else
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_MAC_CHK)];
						memset(ble_work_stat.Ble_mac,0,6);
						s_BLE_init_state = S_BLEINIT_MAC;
					}
					break;
				}
				default:
					break;
			}	
		}
		break;
		
		case S_BLEINIT_NAME_SET:	//㲥
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char *)ble_temp_arr, 10))	//ַҪ޸Ӧڽ֮ǰ޸
			{
				case ResultOk:
					for(init_cnt = 0; init_cnt < 10; init_cnt++)
					{
						ble_work_stat.Ble_name[init_cnt] = ble_temp_arr[init_cnt];	//óɹ󣬸
					}
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_MAC_CHK)];
					memset(ble_work_stat.Ble_mac,0,6);
					s_BLE_init_state = S_BLEINIT_MAC;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_MAC:		//ȡMACַ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:	//ȡɹ
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					if(g_ble_at_rcv_len > BLE_NAME_MAX_LEN)
					{
						g_ble_at_rcv_len = BLE_NAME_MAX_LEN;
					}
					format_ascii2hex(ble_work_stat.Ble_mac, p_ble_at_rcv_data, g_ble_at_rcv_len);
				case ResultError:
				case ResultFail:
				{
					init_flag = FALSE;
					for(init_i = 0; init_i < 6; init_i++)
					{
						if(Sys_data_object.P1.met_addr[5 - init_i] != ble_work_stat.Ble_mac[init_i])
						{
							init_flag = TRUE;
							break;
						}
					}
					
					if(init_flag && CheckMetAddrIfInit())	//ַǳʼַȫ0
					{
						u8 i = 0;
						for(i = 0; i < 6; i++)
						{
							ble_white_MAC_set[i] = Sys_data_object.P1.met_addr[5 - i];//MAC
						}
						format_Hex2ascii(ble_temp_arr, &ble_white_MAC_set[0],6);
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_MAC)];
						init_flag = FALSE;
						s_BLE_init_state = S_BLEINIT_MAC_SET;
					}
					else
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_TXPOWER_CHK)];
						s_BLE_init_state = S_BLEINIT_TXPOW;
					}
					break;
				}
				default:
					break;
			}		
		}
		break;
		
		case S_BLEINIT_MAC_SET:		//MACַ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char *)ble_temp_arr, 12))
			{
				case ResultOk:
					for(init_cnt = 0; init_cnt < 6; init_cnt++)
					{
						ble_work_stat.Ble_mac[init_cnt] = ble_white_MAC_set[init_cnt];	//óɹ󣬸
					}
					init_flag = TRUE;
				case ResultError:
				case ResultFail:
				{
					if(init_flag)
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SAVE)];
						s_BLE_init_state = S_BLEINIT_MAC_SAVE;
					}
					else
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_TXPOWER_CHK)];
						s_BLE_init_state = S_BLEINIT_TXPOW;
					}					
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_MAC_SAVE:	//õMAC
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_RESET)];
					s_BLE_init_state = S_BLEINIT_MAC_RESET;	
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_MAC_RESET:	//MACλ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_init_state = S_BLE_IDLE;			//긴λüִ
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_TXPOW:		//ѯģ鵱ǰ书
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				{
					init_flag = FALSE;
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					if((g_ble_at_rcv_len == 1) && (Sys_data_object.P3.function_switch.ble_tx_power == (p_ble_at_rcv_data[0] - 0x30)))	//书ʵķֵΪ1ֽڣԼһ,ò
					{
						init_flag = TRUE;
					}					
					
					if(TRUE == init_flag)	//ѯֵԼõĲһ£ò
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADVPARAM_CHK)];					
						s_BLE_init_state = S_BLEINIT_ADVPERIOD;
					}
					else
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_TXPOWER)];
						memset(ble_temp_arr,0,sizeof(ble_temp_arr));
						ble_temp_len = format_Dec2ascii(ble_temp_arr,(u16)Sys_data_object.P3.function_switch.ble_tx_power);
						s_BLE_init_state = S_BLEINIT_TXPOW_SET;
					}
					
					break;
				}
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_TXPOWER)];
					memset(ble_temp_arr,0,sizeof(ble_temp_arr));
					ble_temp_len = format_Dec2ascii(ble_temp_arr,(u16)Sys_data_object.P3.function_switch.ble_tx_power);
					s_BLE_init_state = S_BLEINIT_TXPOW_SET;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_TXPOW_SET:		//书
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char *)ble_temp_arr, ble_temp_len))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADVPARAM_CHK)];
					s_BLE_init_state = S_BLEINIT_ADVPERIOD;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_ADVPERIOD:		//ѯģ㲥
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				{
					init_flag = TRUE;
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					ble_temp_data.to_uint16 = Sys_data_object.P3.function_switch.ble_adv_fre * 1000;		//תΪms
					memset(ble_temp_arr,0,sizeof(ble_temp_arr));
					ble_temp_len = format_Dec2ascii(ble_temp_arr,ble_temp_data.to_uint16);
					if(ble_temp_len == g_ble_at_rcv_len)
					{
						for(init_cnt = 0; init_cnt < ble_temp_len; init_cnt++)
						{
							if(ble_temp_arr[init_cnt] != p_ble_at_rcv_data[init_cnt])
							{
								init_flag = FALSE;
								break;
							}
						}
					}
					else
					{
						init_flag = FALSE;
					}
					if(TRUE == init_flag)
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_CONPARAM_CHK)];
						s_BLE_init_state = S_BLEINIT_CONPERIOD;
					}
					else
					{
						ble_temp_data.to_uint16 = Sys_data_object.P3.function_switch.ble_adv_fre * 1000;		//תΪms
						memset(ble_temp_arr,0,sizeof(ble_temp_arr));
						ble_temp_len = format_Dec2ascii(ble_temp_arr,ble_temp_data.to_uint16);
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADVPARAM)];
						s_BLE_init_state = S_BLEINIT_ADVPERIOD_SET;
					}
					break;
				}
				case ResultError:
				case ResultFail:
				{
					ble_temp_data.to_uint16 = Sys_data_object.P3.function_switch.ble_adv_fre * 1000;		//תΪms
					memset(ble_temp_arr,0,sizeof(ble_temp_arr));
					ble_temp_len = format_Dec2ascii(ble_temp_arr,ble_temp_data.to_uint16);
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADVPARAM)];
					s_BLE_init_state = S_BLEINIT_ADVPERIOD_SET;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_ADVPERIOD_SET:		//㲥
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_temp_arr, ble_temp_len))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_CONPARAM_CHK)];
					s_BLE_init_state = S_BLEINIT_CONPERIOD;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_CONPERIOD:		//ѯģӼBLEӺͨ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				{
					init_flag = TRUE;
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					memset(ble_temp_arr,0,sizeof(ble_temp_arr));
					ble_temp_len = format_Dec2ascii(ble_temp_arr,(u16)Sys_data_object.P3.function_switch.ble_con_para);
					if(ble_temp_len == g_ble_at_rcv_len)
					{
						for(init_cnt = 0; init_cnt < ble_temp_len; init_cnt++)
						{
							if(ble_temp_arr[init_cnt] != p_ble_at_rcv_data[init_cnt])
							{
								init_flag = FALSE;
								break;
							}
						}
					}
					else
					{
						init_flag = FALSE;
					}
					if(TRUE == init_flag)
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV1)];
						s_BLE_init_state = S_BLEINIT_ADV_CTL;
					}
					else
					{
						memset(ble_temp_arr,0,sizeof(ble_temp_arr));
						ble_temp_len = format_Dec2ascii(ble_temp_arr,(u16)Sys_data_object.P3.function_switch.ble_con_para);
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_CONPARAM)];
						s_BLE_init_state = S_BLEINIT_CONPERIOD_SET;
					}
					break;
				}
				case ResultError:
				case ResultFail:
				{
					memset(ble_temp_arr,0,sizeof(ble_temp_arr));
					ble_temp_len = format_Dec2ascii(ble_temp_arr,(u16)Sys_data_object.P3.function_switch.ble_con_para);
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_CONPARAM)];
					s_BLE_init_state = S_BLEINIT_CONPERIOD_SET;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_CONPERIOD_SET:		//Ӽ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_temp_arr, ble_temp_len))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV1)];
					s_BLE_init_state = S_BLEINIT_ADV_CTL;
					break;
				}
				default:
					break;
			}
		}
        break;
		
//        case S_BLEINIT_ADVMFID_SET:		//ù㲥
//		{
//			//ǰ
//			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_work_stat.Ble_adv_data, 13))
//			{
//				case ResultOk:
//				case ResultError:
//				case ResultFail:
//				{
//					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV1)];
//					s_BLE_init_state = S_BLEINIT_ADV_CTL;
//					break;
//				}
//				default:
//					break;
//			}
//			break;
//		}
			
		case S_BLEINIT_ADV_CTL:			//򿪹㲥
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					s_BLE_init_state = S_BLEINIT_END;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLEINIT_END:		//ʼ
        {
			BleUartChangeStyle(BLE_cst_AT_NOMAL_RCV);
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_init_state = S_BLE_IDLE;
        }
        break;

		default:
		{
			BleUartChangeStyle(BLE_cst_AT_NOMAL_RCV);
			g_ble_task_flag = BLE_TASK_SUCCESS;
            s_BLE_init_state = S_BLE_IDLE;
		}
        break;
    }
}

/***************************************************************************
* @fun_name		void BleStartInitTask(void)
* @brief		BLEʼ
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
u8 s_ble_is_initing = 0;
void BleStartInitTask(void)
{
	s_BLE_init_state = S_BLEINIT_POWER_ON;
	s_BLE_main_state = S_BLE_MAIN_INIT;
	
	ble_work_stat.Ble_cur_mode = SLAVE_MODE;
	ble_work_stat.Ble_scan_state = SCAN_END;
	ble_work_stat.Ble_con_state = CON_END;
	s_ble_is_initing = 1;
}

#if BLE_CENTRAL_SLAVE_MOD
/************************************************************************************************************************************
* 
*									ģʽл
*
************************************************************************************************************************************/

/***************************************************************************
* @fun_name		void BleCentralSwitchMachine(void)
* @brief		ģʽл״̬
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		лΪӻ1ǰΪģʽ2Ͽ
* @other		ӻлΪ1ǰΪӻģʽ2Ͽӣ3ֹͣ㲥
***************************************************************************/
void BleCentralSwitchMachine(void)
{
	u8 bleswitchflag = FALSE;
	static u8 blecurmode = FALSE;
	switch(s_BLE_mode_switch_state)
	{
		case S_BLE_IDLE:
		{
		}
		break;
		
		//лΪģʽ
		case S_BLE_SWITCH_CENTRAL:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_STATUS)];
				s_BLE_mode_switch_state = S_BLE_SWITCH_CENTRAL_CHK;
			}
		}
		break;
		
		case S_BLE_SWITCH_CENTRAL_CHK:	//ѯǰ״̬
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				{
					bleswitchflag = FALSE;
					blecurmode = FALSE;
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					if(g_ble_at_rcv_len <= 3)
					{
						if((0x30 == p_ble_at_rcv_data[2]) && (',' == p_ble_at_rcv_data[1]))		//0ΪϿ
						{
							bleswitchflag = TRUE;
						}
						if((0x31 == p_ble_at_rcv_data[0]) && (',' == p_ble_at_rcv_data[1]))		//1Ϊģʽ
						{
							blecurmode = TRUE;
						}
					}
					
					if(bleswitchflag)		//ǰѶϿ
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV0)];
						s_BLE_mode_switch_state = S_BLE_SWITCH_ADV0;
					}
					else
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_DISCON)];
						s_BLE_mode_switch_state = S_BLE_SWITCH_CENTRAL_DISCON;
					}
				}
				break;
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_DISCON)];
					s_BLE_mode_switch_state = S_BLE_SWITCH_CENTRAL_DISCON;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SWITCH_CENTRAL_DISCON:	//Ͽ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV0)];
					s_BLE_mode_switch_state = S_BLE_SWITCH_ADV0;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SWITCH_ADV0:		//ֹͣ㲥
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					if(blecurmode)		//ǰΪģʽ
					{
						ble_work_stat.Ble_cur_mode = CENTRAL_MODE;
						g_ble_task_flag = BLE_TASK_SUCCESS;
						s_BLE_mode_switch_state = S_BLE_IDLE;
					}
					else
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_CENTRAL)];
						s_BLE_mode_switch_state = S_BLE_SWITCH_SET_CENTRAL;
					}
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SWITCH_SET_CENTRAL:	//лΪģʽ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				{
					ble_work_stat.Ble_cur_mode = CENTRAL_MODE;
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_mode_switch_state = S_BLE_IDLE;
				}
				break;
				case ResultError:
				case ResultFail:
				{
					ble_work_stat.Ble_cur_mode = MODE_ERROR;		//ģʽлʧ
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_mode_switch_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		//лΪӻģʽ
		case S_BLE_SWITCH_SLAVE:		
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_STATUS)];
				s_BLE_mode_switch_state = S_BLE_SWITCH_SLAVE_CHK;
			}
		}
		break;
		
		case S_BLE_SWITCH_SLAVE_CHK:	//ѯǰ״̬
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				{
					bleswitchflag = FALSE;
					blecurmode = FALSE;
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					if(g_ble_at_rcv_len <= 3)
					{
						if((0x30 == p_ble_at_rcv_data[2]) && (',' == p_ble_at_rcv_data[1]))		//0ΪϿ
						{
							bleswitchflag = TRUE;
						}
						if((0x30 == p_ble_at_rcv_data[0]) && (',' == p_ble_at_rcv_data[1]))		//0Ϊӻ
						{
							blecurmode = TRUE;
						}
					}
					
					if(bleswitchflag)		//ǰѶϿ
					{
						if(blecurmode)		//Ǵӻ
						{
							p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV1)];
							s_BLE_mode_switch_state = S_BLE_SWITCH_ADV1;
						}
						else
						{
							p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SLAVE)];
							s_BLE_mode_switch_state = S_BLE_SWITCH_SET_SLAVE;
						}
					}
					else
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_DISCON)];
						s_BLE_mode_switch_state = S_BLE_SWITCH_SLAVE_DISCON;
					}
				}
				break;
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_DISCON)];
					s_BLE_mode_switch_state = S_BLE_SWITCH_SLAVE_DISCON;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SWITCH_SLAVE_DISCON:		//Ͽ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					if(blecurmode)		//Ǵӻ
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV1)];
						s_BLE_mode_switch_state = S_BLE_SWITCH_ADV1;
					}
					else
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SLAVE)];
						s_BLE_mode_switch_state = S_BLE_SWITCH_SET_SLAVE;
					}					
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SWITCH_SET_SLAVE:		//Ϊӻ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
					ble_work_stat.Ble_cur_mode = SLAVE_MODE;
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV1)];
					s_BLE_mode_switch_state = S_BLE_SWITCH_ADV1;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SWITCH_ADV1:			//㲥
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				{
					ble_work_stat.Ble_cur_mode = SLAVE_MODE;
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_mode_switch_state = S_BLE_IDLE;
				}
				break;
				case ResultError:
				case ResultFail:
				{
					ble_work_stat.Ble_cur_mode = MODE_ERROR;		//ģʽлʧ
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_mode_switch_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}			
		break;			
		
		default:
		{
			ble_work_stat.Ble_cur_mode = MODE_ERROR;		//ģʽлʧ
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_mode_switch_state = S_BLE_IDLE;
		}
		break;
	}
}

/***************************************************************************
* @fun_name		void BleCentralSwitchTask(u8 switch_type)
* @brief		ģʽл
* @param[in]	switch_type:CENTRAL_MODEģʽ,SLAVE_MODEӻģʽ
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleCentralSwitchTask(u8 switch_type)
{
	if((CENTRAL_MODE != switch_type) && (SLAVE_MODE != switch_type))		//ģʽʱĬΪӻ
	{
		switch_type = SLAVE_MODE;
	}
	BleChkLowpowerState();
	switch(switch_type)
	{
		case CENTRAL_MODE:
		{
//			if(CENTRAL_MODE != ble_work_stat.Ble_cur_mode)	//ǰģʽ
			{
				s_BLE_mode_switch_state = S_BLE_SWITCH_CENTRAL;
				s_BLE_main_state = S_BLE_MAIN_CENTRAL_SWITCH;
				ble_work_stat.Ble_cur_mode = MODE_ERROR;
			}
		}
		break;
		
		case SLAVE_MODE:
		{
//			if(CENTRAL_MODE == ble_work_stat.Ble_cur_mode)		//ǰΪģʽ
			{
				s_BLE_mode_switch_state = S_BLE_SWITCH_SLAVE;
				s_BLE_main_state = S_BLE_MAIN_CENTRAL_SWITCH;
				ble_work_stat.Ble_cur_mode = MODE_ERROR;
			}
		}
		break;
	}

}
/***************************************************************************
* @fun_name		u8 BleGetCurMode(void)
* @brief		ȡǰģʽ
* @param[in]	NONE
* @param[out]	None
* @retval		SLAVE_MODECENTRAL_MODEMODE_ERROR
* @other		None
***************************************************************************/
u8 BleGetCurMode(void)
{
	return ble_work_stat.Ble_cur_mode;
}

/************************************************************************************************************************************
*									            ɨ
************************************************************************************************************************************/
/***************************************************************************
* @fun_name		void BleScanMachine(void)
* @brief		ɨ״̬
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleScanMachine(void)
{
	switch(s_BLE_scan_state)
	{
		case S_BLE_IDLE:
		{
		}
		break;
		
		case S_BLE_SCAN_START:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_DISCON)];
				s_BLE_scan_state = S_BLE_SCAN_DISCON;
			}
		}
		break;
		
		case S_BLE_SCAN_DISCON:		//Ͽ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SCAN)];
					s_BLE_scan_state = S_BLE_SCAN_ING;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SCAN_ING:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					ble_work_stat.Ble_scan_state = SCAN_ING;		//ɨ
					Set100msTimer(TIMER_100MS_BLE_SCAN, 500);		//ɨʱ	50s
					BleUartChangeStyle(BLE_cst_AT_SCAN_RCV);		//лɨ
					BleClrScanCompleteFlag();						//ɨɱ־
					BleClrMacBuf();									//ɨݻ
					s_BLE_scan_state = S_BLE_SCAN_OVERTIME;
					break;
				}
				default:
					break;
			}
		}
		break;		
		
		case S_BLE_SCAN_OVERTIME:
		{
			if((0 == Check100msTimer(TIMER_100MS_BLE_SCAN)) || (TRUE == BleGetScanCompleteFlag()))		//ɨ賬ʱ
			{
				ble_work_stat.Ble_scan_state = SCAN_END;		//ɨ
				g_ble_task_flag = BLE_TASK_SUCCESS;
				s_BLE_scan_state = S_BLE_IDLE;
			}
		}
		break;
		
		case S_BLE_SCAN_STOP:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_STOP_SCAN)];
				BleClrScanCompleteFlag();						//ɨɱ־
				s_BLE_scan_state = S_BLE_SCAN_END;
			}
		}
		break;
		
		case S_BLE_SCAN_END:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					Set100msTimer(TIMER_100MS_BLE_SCAN, 80);		//ɨʱ	8s
					s_BLE_scan_state = S_BLE_SCAN_END_OVERTIME;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SCAN_END_OVERTIME:
		{
			if((0 == Check100msTimer(TIMER_100MS_BLE_SCAN)) || (TRUE == BleGetScanCompleteFlag()))		//ɨ賬ʱ
			{
				ble_work_stat.Ble_scan_state = SCAN_END;		//ɨ
				Set100msTimer(TIMER_100MS_BLE_SCAN, 0);
				g_ble_task_flag = BLE_TASK_SUCCESS;
				s_BLE_scan_state = S_BLE_IDLE;
			}
		}
		break;
		
		default:
			ble_work_stat.Ble_scan_state = SCAN_END;		//ɨ
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_scan_state = S_BLE_IDLE;
			break;
	}
}

/***************************************************************************
* @fun_name		u8 BleScanTask(u8 scan_order)
* @brief		ֹͣɨ
* @param[in]	scan_order:SACN_START_ORDERɨ,SACN_STOP_ORDERֹͣɨ
* @param[out]	None
* @retval		None
* @other		ɨ1״̬2Ͽӣ3ǰδɨ״̬
* @other		ֹͣɨ1ǰɨ״̬
***************************************************************************/
u8 BleScanTask(u8 scan_order)
{
	u8 re_result = FALSE;
	BleChkLowpowerState();
	switch(scan_order)
	{
		case SACN_START_ORDER:	//ɨ
		{
			if((SCAN_END == ble_work_stat.Ble_scan_state) && (CENTRAL_MODE == ble_work_stat.Ble_cur_mode))
			{
				s_BLE_scan_state = S_BLE_SCAN_START;
				s_BLE_main_state = S_BLE_MAIN_SCAN;
				ble_work_stat.Ble_scan_state = SCAN_START;
				re_result = TRUE;
			}
		}
		break;
		
		case SACN_STOP_ORDER:	//ɨ
		{
			if(SCAN_ING == ble_work_stat.Ble_scan_state)
			{
				s_BLE_scan_state = S_BLE_SCAN_STOP;
				s_BLE_main_state = S_BLE_MAIN_SCAN;
				re_result = TRUE;
			}
		}
		break;
	}
	return re_result;
}

/***************************************************************************
* @fun_name		u8 BleGetCurScanState(void)
* @brief		ȡǰɨ״̬
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		SCAN_ENDɨδɨ裬SCAN_INGɨ
***************************************************************************/
u8 BleGetCurScanState(void)
{
	return ble_work_stat.Ble_scan_state;
}
#endif
/************************************************************************************************************************************
*									            ״̬
************************************************************************************************************************************/
/***************************************************************************
* @fun_name		void BleConMgrMachine(void)
* @brief		״̬
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleConMgrMachine(void)
{
	//u8 temp_con_flag = FALSE;
    switch (s_BLE_conmgr_state)
    {
		case S_BLE_IDLE:
		{
			
		}
		break;
#if BLE_CENTRAL_SLAVE_MOD		
		case S_BLE_CON_START:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_STATUS)];
				s_BLE_conmgr_state = S_BLE_CON_STATE_CHEK;	
			}
		}
		break;
		
		case S_BLE_CON_STATE_CHEK:	//ѯǰ״̬
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				{
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					temp_con_flag = FALSE;
					if(g_ble_at_rcv_len <= 3)
					{
						if((0x31 == p_ble_at_rcv_data[2]) && (',' == p_ble_at_rcv_data[1]))		//1Ϊ
						{
							temp_con_flag = TRUE;
						}
					}
					if(temp_con_flag)		//ǰΪ״̬ȶϿֱ
					{			
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_DISCON)];
						s_BLE_conmgr_state = S_BLE_CON_DISCON;
					}
					else
					{
//						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_CONNECT)];
//						s_BLE_conmgr_state = S_BLE_CON_RECON;
						s_BLE_conmgr_state = S_BLE_CON_DISCON_WAIT;		//ȥжϵǰǷΪ
					}
				}
				break;
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_DISCON)];
					s_BLE_conmgr_state = S_BLE_CON_DISCON;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CON_DISCON:		//Ͽ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					Set5msTimer(TIMER_5MS_BLE_CON_WAIT,100);
					s_BLE_conmgr_state = S_BLE_CON_DISCON_WAIT;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CON_DISCON_WAIT:	//Ͽʱ
		{
			if(0 == Check5msTimer(TIMER_5MS_BLE_CON_WAIT))
			{
				if(Sys_data_object.P1.function_switch.ies_double_switch.password_enable)	//ԣҪһеļϢ
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_CLRBNDE)];
					s_BLE_conmgr_state = S_BLE_CON_CLRBNDE;
				}
				else
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_CONNECT)];
					s_BLE_conmgr_state = S_BLE_CON_RECON;
				}
			}
		}
		break;
		
		case S_BLE_CON_CLRBNDE:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_CONNECT)];
					s_BLE_conmgr_state = S_BLE_CON_RECON;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CON_RECON:		//½
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_work_stat.Ble_con_MAC, 12))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					Set100msTimer(TIMER_100MS_BLE_CON,220);		//ӳʱʱ22s
					s_BLE_conmgr_state = S_BLE_CON_RECON_R;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CON_RECON_R:
		{
			if(0 == Check100msTimer(TIMER_100MS_BLE_CON))
			{
				ble_work_stat.Ble_con_state = CON_END;			//δ
				g_ble_task_flag = BLE_TASK_SUCCESS;
				s_BLE_conmgr_state = S_BLE_IDLE;
			}
			else
			{
				if(Gpio_GetInputIO(BLE_CON_PORT, BLE_CON_PIN))		//Ӹߵƽ
				{
					Set5msTimer(TIMER_5MS_BLE_CON_WAIT,100);
					s_BLE_conmgr_state = S_BLE_CON_RECON_XIAODOU;
				}
			}
		}
		break;
		
		case S_BLE_CON_RECON_XIAODOU:		//ߵƽ
		{
			if(0 == Check5msTimer(TIMER_5MS_BLE_CON_WAIT))
			{
				ble_work_stat.Ble_con_state = CON_ING;				//
				g_ble_task_flag = BLE_TASK_SUCCESS;
				s_BLE_conmgr_state = S_BLE_IDLE;
			}
			else
			{
				if(!Gpio_GetInputIO(BLE_CON_PORT, BLE_CON_PIN))		//͵ƽ
				{
					s_BLE_conmgr_state = S_BLE_CON_RECON_R;
				}
			}
		}
		break;
#endif		
		case S_BLE_CON_STOP:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_DISCON)];
				s_BLE_conmgr_state = S_BLE_CON_END;
			}
		}
		break;
		
		case S_BLE_CON_END:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				{
					ble_work_stat.Ble_con_state = CON_END;		//ֻзokӽ
				}
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_conmgr_state = S_BLE_IDLE;
				}
				default:
					break;
			}
		}
		break;

		default:
		{
			ble_work_stat.Ble_con_state = CON_END;		//ӽ
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_conmgr_state = S_BLE_IDLE;
		}
		break;
	}
}

/***************************************************************************
* @fun_name		u8 BleConMacTask(u8 con_order,u8 *con_mac)
* @brief		BleϿ
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
u8 BleConMacTask(u8 con_order,u8 *con_mac)
{
	u8 con_result = FALSE;
	BleChkLowpowerState();
#if BLE_CENTRAL_SLAVE_MOD
	if((CON_START_ORDER == con_order) && (CENTRAL_MODE == ble_work_stat.Ble_cur_mode))		//
	{
		format_Hex2ascii(ble_work_stat.Ble_con_MAC,con_mac,6);
		s_BLE_conmgr_state = S_BLE_CON_START;
		s_BLE_main_state = S_BLE_MAIN_CONNECT;
		ble_work_stat.Ble_con_state = CON_START;//δ
		con_result = TRUE;
	}
	else if(CON_STOP_ORDER == con_order)		//Ͽ
	{
		s_BLE_conmgr_state = S_BLE_CON_STOP;
		s_BLE_main_state = S_BLE_MAIN_CONNECT;
		con_result = TRUE;
	}
#else
	if(CON_STOP_ORDER == con_order)		//Ͽ
	{
		s_BLE_conmgr_state = S_BLE_CON_STOP;
		s_BLE_main_state = S_BLE_MAIN_CONNECT;
		con_result = TRUE;
	}
#endif
	return con_result;
}

/***************************************************************************
* @fun_name		u8 BleGetCurConState(u8* ptr_con_mac)
* @brief		ȡǰ״̬
* @param[in]	None
* @param[out]	ǰӵMAC
* @retval		CON_STARTʼӣCON_END:δӣCON_ING
* @other		None
***************************************************************************/
//u8 BleGetCurConState(u8* ptr_con_mac)
//{
//	memcpy(ptr_con_mac,ble_work_stat.Ble_con_MAC,12);
//	return ble_work_stat.Ble_con_state;
//}
u8 BleGetCurConState(void)
{
	return ble_work_stat.Ble_con_state;
}

/************************************************************************************************************************************
*									            ƼMAC
************************************************************************************************************************************/
/***************************************************************************
* @fun_name		void BleChangeMACMachine(void)
* @brief		Ble޸ƼMACַ
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleChangeMACMachine(void)
{
	switch(s_BLE_change_mac_state)
	{
		case S_BLE_IDLE:
		{
		}
		break;
		
		case S_BLE_MAC_SET_START:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_DISCON)];
				s_BLE_change_mac_state = S_BLE_MAC_DISCON;	//ȶϿ,޸MACַ
			}
		}
		break;
		
		case S_BLE_MAC_DISCON:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					ble_work_stat.Ble_con_state = CON_END;			//ӽ
					if(CENTRAL_MODE != ble_work_stat.Ble_cur_mode)	//ģʽ
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV0)];
						s_BLE_change_mac_state = S_BLE_MAC_ADV0;
					}
					else
					{
						p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_NAME)];
						s_BLE_change_mac_state = S_BLE_MAC_NAME;
					}
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_MAC_ADV0:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_NAME)];
					s_BLE_change_mac_state = S_BLE_MAC_NAME;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_MAC_NAME:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_work_stat.Ble_name, 10))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					format_Hex2ascii(ble_temp_arr,ble_work_stat.Ble_mac,6);
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_MAC)];
					s_BLE_change_mac_state = S_BLE_MAC_MAC;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_MAC_MAC:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_temp_arr, 12))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SAVE)];
					s_BLE_change_mac_state = S_BLE_MAC_SAVE;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_MAC_SAVE:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_RESET)];
					s_BLE_change_mac_state = S_BLE_MAC_RESET;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_MAC_RESET:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_change_mac_state = S_BLE_IDLE;
				}
				default:
					break;
			}
		}
		break;
		
//		case S_BLE_MAC_ADV1:
//		{
//			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
//			{
//				case ResultOk:
//				case ResultError:
//				case ResultFail:
//				{
//					g_ble_task_flag = BLE_TASK_SUCCESS;
//					s_BLE_change_mac_state = S_BLE_IDLE;
//				}
//				default:
//					break;
//			}
//		}
//		break;
		
		//ѯ
		case S_BLE_MAC_CHK_START:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_NAME_CHK)];
				s_BLE_change_mac_state = S_BLE_MAC_NAME_CHK;
			}
		}
		break;
		case S_BLE_MAC_NAME_CHK:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_MAC_CHK)];
					s_BLE_change_mac_state = S_BLE_MAC_MAC_CHK;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_MAC_MAC_CHK:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_change_mac_state = S_BLE_IDLE;
				}
				default:
					break;
			}
		}
		break; 
		
		default:
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_change_mac_state = S_BLE_IDLE;
			break;
	}
}

/***************************************************************************
* @fun_name		void BleNameMacTask(u8 opr_type,u8 src_len)
* @brief		Ble޸ƼMACַ
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleNameMacTask(u8 opr_type,u8* name_src)
{
	BleChkLowpowerState();
	switch(opr_type)
	{
		case CHK_NAME_MAC:
		{
			s_BLE_change_mac_state = S_BLE_MAC_CHK_START;
			s_BLE_main_state = S_BLE_MAIN_NAME_MAC;
		}
		break;
		
		case SET_NAME_MAC:
		{
			u8 nme_temp_i = 0;
			//NAME
			for(nme_temp_i = 0; nme_temp_i < 5; nme_temp_i++)
			{
				ble_work_stat.Ble_name[nme_temp_i * 2] = (name_src[4 - nme_temp_i] >> 4) + 0x30;
				ble_work_stat.Ble_name[nme_temp_i * 2 + 1] = (name_src[4 - nme_temp_i] & 0x0F) + 0x30;
			}

			//MAC
			for(nme_temp_i = 0; nme_temp_i < 6; nme_temp_i++)
			{
				ble_work_stat.Ble_mac[nme_temp_i] =  *(name_src + 5 - nme_temp_i);
			}
			s_BLE_change_mac_state = S_BLE_MAC_SET_START;
			s_BLE_main_state = S_BLE_MAIN_NAME_MAC;
		}
		break;
	}
	
}

/************************************************************************************************************************************
*									            㲥
************************************************************************************************************************************/
/***************************************************************************
* @fun_name		void BleUpdateAavDataMachine(void)
* @brief		Ble¹㲥
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleUpdateAavDataMachine(void)
{
	switch(s_BLE_update_adv_data_state)
	{
		case S_BLE_IDLE:
		{
		}
		break;
		
		case S_BLE_UPDATE_ADV_START:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADVMFID)];
				s_BLE_update_adv_data_state = S_BLE_UPDATE_ADV;
			}
		}
		break;
		
		case S_BLE_UPDATE_ADV:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_work_stat.Ble_adv_data, 13))
			{
				case ResultOk:
				case ResultError:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_MAC_CHK)];
					memset(ble_temp_arr,0,sizeof(ble_temp_arr));
					s_BLE_update_adv_data_state = S_BLE_UPDATE_ADV_RD_MAC;
				}
				break;
				case ResultFail:
				{	
					g_ble_task_flag = BLE_TASK_FAIL;//¹㲥쳣ʱʾĸλ
					s_BLE_update_adv_data_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_UPDATE_ADV_RD_MAC:			//¹㲥ʱͬʱȡһMACжǷַһ£Ƿиλ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				{
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					if(g_ble_at_rcv_len > BLE_NAME_MAX_LEN)
					{
						g_ble_at_rcv_len = BLE_NAME_MAX_LEN;
					}
					format_ascii2hex(ble_temp_arr, p_ble_at_rcv_data, g_ble_at_rcv_len);
				}
				case ResultError:
				case ResultFail:
				{
					u8 temp_num;
					
					if(CheckMetAddrIfInit())		//ַ
					{
						for(temp_num = 0; temp_num < 6; temp_num++)
						{
							if(ble_temp_arr[temp_num] != Sys_data_object.P1.met_addr[5 - temp_num])
							{
								break;
							}
						}
					}
					if(temp_num>=6)
					{
						g_ble_task_flag = BLE_TASK_SUCCESS;
						s_BLE_update_adv_data_state = S_BLE_IDLE;
					}
					else//MACַַһ,ʧܽ
					{
						g_ble_task_flag = BLE_TASK_FAIL;
						s_BLE_update_adv_data_state = S_BLE_IDLE;
					}
				}
				break;
				default:
					break;
			}
		}
		break;
		
		default:
		{
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_update_adv_data_state = S_BLE_IDLE;
		}
		break;
	}
}

/***************************************************************************
* @fun_name		u8 BleUpdataAdvDataTask(u8* snd_data)
* @brief		Ble¹㲥
* @param[in]	µ
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
u8 BleUpdataAdvDataTask(u8* snd_data)
{
	u8 adv_data_result = FALSE;
	u8 adv_data_len = 0;
	BleChkLowpowerState();
	if((CENTRAL_MODE != ble_work_stat.Ble_cur_mode) && (CON_ING != ble_work_stat.Ble_con_state))	//ģʽ״̬
	{
		for(adv_data_len = 0; adv_data_len < 13; adv_data_len++)
		{
			ble_work_stat.Ble_adv_data[adv_data_len] = *(snd_data + adv_data_len);
		}
		s_BLE_update_adv_data_state = S_BLE_UPDATE_ADV_START;
		s_BLE_main_state = S_BLE_MAIN_ADV_DATA;
		adv_data_result = TRUE;
	}
	return adv_data_result;
}

/************************************************************************************************************************************
*									            
************************************************************************************************************************************/
/***************************************************************************
* @fun_name		void BleChangeAdvParasMachine(void)
* @brief		Ble²
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleChangeAdvParasMachine(void)
{
	switch(s_BLE_change_adv_para_state)
	{
		case S_BLE_IDLE:
		{
		}
		break;
		
		case S_BLE_CHANGE_ADV_START:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV0)];
				s_BLE_change_adv_para_state = S_BLE_CHANGE_ADV0;
			}	
		}
		break;
		
		case S_BLE_CHANGE_ADV0:				//ֹͣ㲥
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					ble_temp_data.to_uint16 = Sys_data_object.P3.function_switch.ble_adv_fre * 1000;
					ble_temp_len = format_Dec2ascii(ble_temp_arr,ble_temp_data.to_uint16);
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADVPARAM)];
					s_BLE_change_adv_para_state = S_BLE_CHANGE_ADV_PARAM;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CHANGE_ADV_PARAM:			//޸Ĺ㲥
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_temp_arr, ble_temp_len))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					ble_temp_len = format_Dec2ascii(ble_temp_arr,(u16)Sys_data_object.P3.function_switch.ble_con_para);
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_CONPARAM)];
					s_BLE_change_adv_para_state = S_BLE_CHANGE_CON_PARAM;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CHANGE_CON_PARAM:		//޸Ӽ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_temp_arr, ble_temp_len))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					ble_temp_len = format_Dec2ascii(ble_temp_arr,(u16)Sys_data_object.P3.function_switch.ble_tx_power);
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_TXPOWER)];
					s_BLE_change_adv_para_state = S_BLE_CHANGE_TX_POWER;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CHANGE_TX_POWER:			//޸ķ书
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_temp_arr, ble_temp_len))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					ble_temp_len = format_Dec2ascii(ble_temp_arr,(u16)Sys_data_object.P3.function_switch.ble_scan_times);
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SCAN_TIMES)];
					s_BLE_change_adv_para_state = S_BLE_CHANGE_SCAN_TIMES;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CHANGE_SCAN_TIMES:			//޸ɨ
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_temp_arr, ble_temp_len))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SAVE)];
					s_BLE_change_adv_para_state = S_BLE_CHANGE_SAVE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CHANGE_SAVE:				//޸ɺ󱣴
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV1)];
					s_BLE_change_adv_para_state = S_BLE_CHANGE_ADV1;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CHANGE_ADV1:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_change_adv_para_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		default:
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_change_adv_para_state = S_BLE_IDLE;
			break;
	}
}

/***************************************************************************
* @fun_name     void BleChangeAdvParaTask()
* @brief        Ble޸Ĺ㲥
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
***************************************************************************/
void BleChangeAdvParaTask(void)
{
	BleChkLowpowerState();
	s_BLE_change_adv_para_state = S_BLE_CHANGE_ADV_START;
	s_BLE_main_state = S_BLE_MAIN_ADV_PARAM;
}

/************************************************************************************************************************************
*									            ؼ
************************************************************************************************************************************/
/***************************************************************************
* @fun_name		void BleSetClearKeyWordMachine(void)
* @brief		Ble޸Ļȡؼ
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleSetClearKeyWordMachine(void)
{
	switch(s_BLE_change_key_word_state)
	{
		case S_BLE_IDLE:
		{
		}
		break;
		
		case S_BLE_CHK_KEY_WORD:		//ѯؼ
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_KEY_CHK)];
				s_BLE_change_key_word_state = S_BLE_CHK_KEY_WORD_R;
			}
		}
		break;
		
		case S_BLE_CHK_KEY_WORD_R:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_change_key_word_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SET_KEY_WORD:	//޸Ĺؼ
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_KEY_SET)];
				s_BLE_change_key_word_state = S_BLE_SET_KEY_WORD_R;
			}
		}
		break;
		
		case S_BLE_SET_KEY_WORD_R:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf,(char*)ble_work_stat.Ble_key_word, ble_work_stat.Ble_key_word_len))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SAVE)];
					s_BLE_change_key_word_state = S_BLE_KEY_WORD_SAVE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_CLEAR_KEY_WORD:	//ȡؼ
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_KEY_CLR)];
				s_BLE_change_key_word_state = S_BLE_CLEAR_KEY_WORD_R;
			}
		}
		break;
		
		case S_BLE_CLEAR_KEY_WORD_R:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SAVE)];
					s_BLE_change_key_word_state = S_BLE_KEY_WORD_SAVE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_KEY_WORD_SAVE:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_change_key_word_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}
		break;

		default:
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_change_key_word_state = S_BLE_IDLE;
			break;
	}
}

/***************************************************************************
* @fun_name		void BleKeyWordTask(u8 type,u8* key_word)
* @brief		Ble޸ġѯȡؼ
* @param[in]	type:ͣkey_word޸ĵĹؼ֣ѯȡʱNULL,key_lenؼֳ
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleKeyWordTask(u8 type,u8* key_word,u8 key_len)
{
	u8 key_temp = 0;
	BleChkLowpowerState();
	switch(type)
	{
		case CHK_KEY_WORD:
		{
			s_BLE_change_key_word_state = S_BLE_CHK_KEY_WORD;
			s_BLE_main_state = S_BLE_MAIN_KEY_WORD;
		}
		break;
		
		case SET_KEY_WORD:
		{
			if((0 == key_len) || (12 <= key_len))
			{
				break;
			}
			ble_work_stat.Ble_key_word_len = key_len;
			for(key_temp = 0; key_temp < key_len; key_temp++)
			{
				ble_work_stat.Ble_key_word[key_temp] = *(key_word + key_temp);
			}
			s_BLE_change_key_word_state = S_BLE_SET_KEY_WORD;
			s_BLE_main_state = S_BLE_MAIN_KEY_WORD;
		}
		break;
		
		case CLR_KEY_WORD:
		{
			s_BLE_change_key_word_state = S_BLE_CLEAR_KEY_WORD;
			s_BLE_main_state = S_BLE_MAIN_KEY_WORD;
		}
		break;
	}
}

/***************************************************************************
* @fun_name     u8 BleGetCurKeyWord(u8* key_addr)
* @brief        ȡBleĹؼ
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        Ȳѯٵøýӿ
***************************************************************************/
u8 BleGetCurKeyWord(u8* key_addr)
{
	u8 temp_i = 0;
	if(0 != ble_work_stat.Ble_key_word_len)
	{
		for(temp_i = 0; temp_i < ble_work_stat.Ble_key_word_len; temp_i++)
		{
			*(key_addr + temp_i) = ble_work_stat.Ble_key_word[temp_i];
		}
		return ble_work_stat.Ble_key_word_len;
	}
	return 0;
}

#if BLE_CENTRAL_SLAVE_MOD
/************************************************************************************************************************************
*									            ɨʱMAC
************************************************************************************************************************************/
/***************************************************************************
* @fun_name		void BleMacWhiteListMachine(void)
* @brief		MAC
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleMacWhiteListMachine(void)
{
	switch(s_BLE_white_list_state)
	{
		case S_BLE_IDLE:
		{
		}
		break;
		
		case S_BLE_WHITE_LIST:		//ð
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				format_Hex2ascii(ble_temp_arr,ble_white_MAC_set,6);
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_WHITE_LIST_SET)];
				s_BLE_white_list_state = S_BLE_WHITE_LIST_R;
			}
		}
		break;
		
		case S_BLE_WHITE_LIST_R:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, (char*)ble_temp_arr, 12))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SAVE)];
					s_BLE_white_list_state = S_BLE_WHITE_LIST_SAVE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_WHITE_LIST_CLR:	//
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_WHITE_LIST_CLR)];
				s_BLE_white_list_state = S_BLE_WHITE_LIST_CLR_R;
			}
		}
		break;
		
		case S_BLE_WHITE_LIST_CLR_R:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SAVE)];
					s_BLE_white_list_state = S_BLE_WHITE_LIST_SAVE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_WHITE_LIST_CHK:	//ѯ
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_WHITE_LIST_CHK)];
				s_BLE_white_list_state = S_BLE_WHITE_LIST_CHK_R;
			}
		}
		break;
		
		case S_BLE_WHITE_LIST_CHK_R:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_white_list_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_WHITE_LIST_SAVE:		//
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_white_list_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		default:
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_white_list_state = S_BLE_IDLE;
			break;
	}
}

/***************************************************************************
* @fun_name     void BleMacWhiteListTask(u8 type,u8* list_addr)
* @brief        ɨMAC
* @param[in]    type:ûȡlist_addr趨İݣȡʱNULL
* @param[out]   None
* @retval       None
* @other        None
***************************************************************************/
void BleMacWhiteListTask(u8 type,u8* list_addr)
{
	u8 list_temp = 0;
	BleChkLowpowerState();
	switch(type)
	{
		case SET_WHITE_LIST:
		{
			for(list_temp = 0; list_temp < 6; list_temp++)
			{
				ble_white_MAC_set[list_temp] = *(list_addr + list_temp);
			}
			s_BLE_white_list_state = S_BLE_WHITE_LIST;
			s_BLE_main_state = S_BLE_MAIN_WHITE_LIST;
		}
		break;
		
		case CLR_WHITE_LIST:
		{
			s_BLE_white_list_state = S_BLE_WHITE_LIST_CLR;
			s_BLE_main_state = S_BLE_MAIN_WHITE_LIST;
		}
		break;
		
		case CHK_WHITE_LIST:
		{
			s_BLE_white_list_state = S_BLE_WHITE_LIST_CHK;
			s_BLE_main_state = S_BLE_MAIN_WHITE_LIST;
		}
		break;
	}
}
#endif

/************************************************************************************************************************************
*									            ѯǰģʽ״̬
************************************************************************************************************************************/
/***************************************************************************
* @fun_name     void BleChkStatusMachine(void)
* @brief        ѯʱģʽ״̬
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        ӦOK+STATUS=A,BAʾģʽ0-ӣ1-Bʾ״̬0-Ͽ1-ӣ
***************************************************************************/
void BleChkStatusMachine(void)
{
	switch(s_BLE_chk_status_state)
	{
		case S_BLE_IDLE:
		{
			;
		}
		break;
		
		case S_BLE_CHK_STATUS:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_STATUS)];
				s_BLE_chk_status_state = S_BLE_CHK_STATUS_R;
			}
		}
		break;
		
		case S_BLE_CHK_STATUS_R:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))	
			{
				case ResultOk:
				{
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					if(g_ble_at_rcv_len <= 3)
					{
						if((0x31 == p_ble_at_rcv_data[0]) && (',' == p_ble_at_rcv_data[1]))		//1Ϊ
						{
							ble_work_stat.Ble_cur_mode = CENTRAL_MODE;
						}
						else if((0x30 == p_ble_at_rcv_data[0]) && (',' == p_ble_at_rcv_data[1]))
						{
							ble_work_stat.Ble_cur_mode = SLAVE_MODE;
						}
						else
						{
							ble_work_stat.Ble_cur_mode = MODE_ERROR;
						}
						
						if((0x31 == p_ble_at_rcv_data[2]) && (',' == p_ble_at_rcv_data[1]))		//1Ϊ
						{
							ble_work_stat.Ble_con_state = CON_ING;
						}
						else if((0x30 == p_ble_at_rcv_data[2]) && (',' == p_ble_at_rcv_data[1]))
						{
							ble_work_stat.Ble_con_state = CON_END;
						}
						else 
						{
							ble_work_stat.Ble_con_state = CON_START;
						}
					}
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_chk_status_state = S_BLE_IDLE;
				}
				break;
				case ResultError:
				case ResultFail:
				{
					ble_work_stat.Ble_con_state = CON_START;
					ble_work_stat.Ble_cur_mode = MODE_ERROR;
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_chk_status_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		default:
		{
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_chk_status_state = S_BLE_IDLE;
		}
		break;
	}
}
/***************************************************************************
* @fun_name     void BleChkStatusTask(void)
* @brief        ѯʱģʽ״̬
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
***************************************************************************/
void BleChkStatusTask(void)
{
	BleChkLowpowerState();
	s_BLE_main_state = S_BLE_MAIN_CHK_STATUS;
	s_BLE_chk_status_state = S_BLE_CHK_STATUS;
}

/************************************************************************************************************************************
*									            ѯԵ
************************************************************************************************************************************/
/***************************************************************************
* @fun_name    	void BleSecPinMachine(void)
* @brief        ѯԵ״̬
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        ģʽ0AT+SEC=0
* @other        ģʽ1AT+SEC=1
* @other        ȡAT+SEC=3
***************************************************************************/
void BleSecPinMachine(void)
{
	switch(s_BLE_sec_status_state)
	{
		case S_BLE_IDLE:
		{
			
		}
		break;
		//ѯ-ͬʱѯSEC״̬PIN
		case S_BLE_CHK_SEC:	//ѯSEC
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SEC_CHK)];
				s_BLE_sec_status_state = S_BLE_CHK_SEC_R;
			}
		}
		break;
		case S_BLE_CHK_SEC_R:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))
			{
				case ResultOk:
				{
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					if(g_ble_at_rcv_len == 1)		//SECѯķֵֻ1ֽ
					{
						if('0' == p_ble_at_rcv_data[0] || '1' == p_ble_at_rcv_data[0] || '3' == p_ble_at_rcv_data[0])
						{
							ble_work_stat.Ble_cur_sec = *p_ble_at_rcv_data - 0x30;
						}
					}
				}
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_PIN_CHK)];
					s_BLE_sec_status_state = S_BLE_CHK_PIN;
					break;
				}
				default:
					break;
			}
		}
		break;
		case S_BLE_CHK_PIN:	//ѯPIN
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))
			{
				case ResultOk:
				{
					g_ble_at_rcv_len = BleRcvAtData(&p_ble_at_rcv_data);
					if(g_ble_at_rcv_len <= 6)		//PINѯķֵΪ6ֽ,صascii
					{
						format_ascii2hex(ble_work_stat.Ble_cur_pin,p_ble_at_rcv_data,g_ble_at_rcv_len);
					}
				}
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_sec_status_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}
		break;		
		
		//--SECPINͬʱãǰرչ㲥ɻʧܺ㲥
		case S_BLE_SET_SEC_ADV0:	//رչ㲥
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV0)];
				s_BLE_sec_status_state = S_BLE_SET_SEC_ADV0_R;
			}
		}
		break;
		case S_BLE_SET_SEC_ADV0_R:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_PIN)];
					s_BLE_sec_status_state = S_BLE_SET_PIN;
					break;
				}
				default:
					break;
			}
		}
		break;
		case S_BLE_SET_PIN:	//PIN
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, ble_default_pin,6))
			{
				case ResultOk:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SEC_SET)];
					s_BLE_sec_status_state = S_BLE_SET_SEC;
				}
				break;
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV1)];
					s_BLE_sec_status_state = S_BLE_SET_SEC_ADV1;
					break;
				}
				default:
					break;
			}
		}
		break;
		case S_BLE_SET_SEC:	//SEC
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_ADV1)];
					s_BLE_sec_status_state = S_BLE_SET_SEC_ADV1;
					break;
				}
				default:
					break;
			}
		}
		break;
		case S_BLE_SET_SEC_ADV1:	//㲥
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SAVE)];
					s_BLE_sec_status_state = S_BLE_SEC_SAVE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		//ȡ
		case S_BLE_CLR_SEC:
		{
			if(0 == Check5msTimer(TIMER_5MS_LOWPOWER))
			{
				p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_SEC_CLR)];
				s_BLE_sec_status_state = S_BLE_CLR_SEC_R;
			}
		}
		break;
		case S_BLE_CLR_SEC_R:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					p_cur_atcmdbuf = &AtCmdBuf[getAtCmdIndex(AT_CODE_RESET)];
					s_BLE_sec_status_state = S_BLE_SEC_RESET;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SEC_RESET:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL, 0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_sec_status_state = S_BLE_IDLE;			//긴λüִ
				}
				default:
					break;
			}
		}
		break;
		
		case S_BLE_SEC_SAVE:
		{
			switch(AT_Requeset_Proc(p_cur_atcmdbuf, NULL,0))
			{
				case ResultOk:
				case ResultError:
				case ResultFail:
				{
					g_ble_task_flag = BLE_TASK_SUCCESS;
					s_BLE_sec_status_state = S_BLE_IDLE;
					break;
				}
				default:
					break;
			}
		}
		break;
		
		default:
		{
			g_ble_task_flag = BLE_TASK_SUCCESS;
			s_BLE_sec_status_state = S_BLE_IDLE;
			break;
		}
	}
}

/***************************************************************************
* @fun_name    	u8 BleSecChkOrSetTask(u8 sec_type)
* @brief        ѯԵӿ
* @param[in]    sec_type:ѯáȡ
* @param[out]   None
* @retval       TRUE:ɹFALSEʧ
* @other        ǰbleifidle
***************************************************************************/
u8 BleSecChkOrSetTask(u8 sec_type)
{
	if(CHK_BLE_SEC == sec_type || SET_BLE_SEC == sec_type || CLR_BLE_SEC == sec_type)
	{
		BleChkLowpowerState();
		if(CHK_BLE_SEC == sec_type)		//ѯ
		{
			s_BLE_main_state = S_BLE_MAIN_SEC_PIN;
			s_BLE_sec_status_state = S_BLE_CHK_SEC;
		}
		else if(SET_BLE_SEC == sec_type)//
		{
			s_BLE_main_state = S_BLE_MAIN_SEC_PIN;
			s_BLE_sec_status_state = S_BLE_SET_SEC_ADV0;
		}
		else if(CLR_BLE_SEC == sec_type)//ȡ
		{
			s_BLE_main_state = S_BLE_MAIN_SEC_PIN;
			s_BLE_sec_status_state = S_BLE_CLR_SEC;
		}
		return TRUE;
	}
	return FALSE;
}

/***************************************************************************
* @fun_name    	u8 BleChkCurSecState(u8 **cur_pin)
* @brief        ѯǰļ״̬PIN
* @param[in]    pinַ
* @param[out]   ǰ
* @retval       SEC״̬0-ȡ1-
* @other        øýӿڣȵòѯӿBleSecChkOrSetTask
***************************************************************************/
u8 BleChkCurSecState(u8 **cur_pin)
{
	*cur_pin = ble_work_stat.Ble_cur_pin;
	return ble_work_stat.Ble_cur_sec;
}

/***************************************************************************
* @fun_name     void BleMainMachine()
* @brief        BleռѭУBle
* @param[in]    None
* @param[out]   None
* @retval       None
* @other        None
***************************************************************************/
void BleMainMachine(void)
{
	if(ble_con_msg == BLE_DISCON_MSG)//Ͽ
	{
		ble_con_msg = BLE_CON_NOMSG;
		ble_work_stat.Ble_con_state = CON_END;
	}
	switch(s_BLE_main_state)
	{
		case S_BLE_IDLE:
		{
			if(ble_con_msg == BLE_CON_MSG)	//Ϣ
			{
				ble_con_msg = BLE_CON_NOMSG; 
				Gpio_SetIO(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN);	//ֻ
				UartInit(BLE_UART_COM, BAUD38400, DATA_BIT_8, STOPBIT_1, UART_EVEN_PARITY, UART_LPUART_Disable);
				Set5msTimer(TIMER_5MS_LOWPOWER,20);//жϺʱ100msֱֹӽ(ܷյ쳣λַ)
				if(Gpio_GetInputIO(BLE_CON_PORT, BLE_CON_PIN)==TRUE)//
				{
					ble_work_stat.Ble_con_state = CON_ING;	//
				}
			}
		}
		break;
		
		case S_BLE_MAIN_INIT:	//ϵ縴λʼ
		{
			if(BLE_TASK_INIT == g_ble_task_flag)
			{
				BleInitMachine();
			}
			else 
			{
				s_BLE_main_state = S_BLE_IDLE;
				if(g_ble_task_flag == BLE_TASK_SUCCESS)//ֹϵѭ
				{
					SaveNewSoe(SOE_20_BLE_INIT, 0x50);//ʼ
					FrameSetMsgApp(MsgBLE_AdvChange);//ʼɹ,¹㲥
					if(Sys_data_object.P3.function_switch.password_enable)	//빦Ƿ
					{ 
						g_ble_task_flag = BLE_TASK_INIT;
						BleSecChkOrSetTask(SET_BLE_SEC);
					}
				}
				else
				{
					SaveNewSoe(SOE_20_BLE_INIT, 0xE0);//ʼ쳣
					BleForcePowerOff(BlePowerWrong);
					if(ble_reset_count<10)
					{
						FrameSetMsgApp(MsgBLE_Clktrim);//ʱУ׼
					}
				}
				g_ble_task_flag = BLE_TASK_INIT;			
			}
		}
		break;
#if BLE_CENTRAL_SLAVE_MOD		
		case S_BLE_MAIN_CENTRAL_SWITCH:	//лģʽ
		{
			if(BLE_TASK_INIT == g_ble_task_flag)
			{
				BleCentralSwitchMachine();
			}
			else 
			{
				g_ble_task_flag = BLE_TASK_INIT;
				s_BLE_main_state = S_BLE_IDLE;
			}
		}
		break;
		
		case S_BLE_MAIN_SCAN:			//ֹͣɨ
		{
			if(BLE_TASK_INIT == g_ble_task_flag)
			{
				BleScanMachine();
			}
			else 
			{
				g_ble_task_flag = BLE_TASK_INIT;
				s_BLE_main_state = S_BLE_IDLE;
			}
		}
		break;
#endif
		
		case S_BLE_MAIN_CONNECT:			//Ͽ
		{
			if(BLE_TASK_INIT == g_ble_task_flag)
			{
				BleConMgrMachine();
			}
			else 
			{
				g_ble_task_flag = BLE_TASK_INIT;
				s_BLE_main_state = S_BLE_IDLE;
			}
		}
		break;
		
		case S_BLE_MAIN_NAME_MAC:		//޸ƼmAC
		{
			if(BLE_TASK_INIT == g_ble_task_flag)
			{
				BleChangeMACMachine();
			}
			else 
			{
				g_ble_task_flag = BLE_TASK_INIT;
				s_BLE_main_state = S_BLE_IDLE;
			}
		}
		break;
		
		case S_BLE_MAIN_ADV_DATA:		//¹㲥
		{
			if(flag_ble_force_power!=BlePowerOk)//ϵ״̬
			{
				s_BLE_main_state = S_BLE_IDLE;	
				BleStartInitTask();//ϵʼ
				g_ble_task_flag = BLE_TASK_INIT;
			}
			else
			{
				if(BLE_TASK_INIT == g_ble_task_flag)
				{
					BleUpdateAavDataMachine();
				}
				else  
				{
					s_BLE_main_state = S_BLE_IDLE;
					if(g_ble_task_flag==BLE_TASK_FAIL)
					{
						SaveNewSoe(SOE_17_BLE_ADV_ERR, 0xE0);//¹㲥쳣
						FrameSetMsgApp(MsgBLE_Clktrim);//ʱУ׼֮
					}
					g_ble_task_flag = BLE_TASK_INIT;
				}
			}
		}
		break;
		
		case S_BLE_MAIN_ADV_PARAM:		//¹㲥
		{
			if(BLE_TASK_INIT == g_ble_task_flag)
			{
				BleChangeAdvParasMachine();
			}
			else 
			{
				g_ble_task_flag = BLE_TASK_INIT;
				s_BLE_main_state = S_BLE_IDLE;
			}
		}
		break;
		
		case S_BLE_MAIN_KEY_WORD:		//¹ؼ
		{
			if(BLE_TASK_INIT == g_ble_task_flag)
			{
				BleSetClearKeyWordMachine();
			}
			else 
			{
				g_ble_task_flag = BLE_TASK_INIT;
				s_BLE_main_state = S_BLE_IDLE;
			}
		}
		break;
#if BLE_CENTRAL_SLAVE_MOD		
		case S_BLE_MAIN_WHITE_LIST:		//MAC
		{
			if(BLE_TASK_INIT == g_ble_task_flag)
			{
				BleMacWhiteListMachine();
			}
			else 
			{
				g_ble_task_flag = BLE_TASK_INIT;
				s_BLE_main_state = S_BLE_IDLE;
			}
		}
		break;
#endif
		case S_BLE_MAIN_CHK_STATUS:	//ѯģʽ״̬
		{
			if(BLE_TASK_INIT == g_ble_task_flag)
			{
				BleChkStatusMachine();
			}
			else 
			{
				g_ble_task_flag = BLE_TASK_INIT;
				s_BLE_main_state = S_BLE_IDLE;
			}
		}
		break;
		
		case S_BLE_MAIN_SEC_PIN:	//ѯSECPIN
		{
			if(BLE_TASK_INIT == g_ble_task_flag)
			{
				BleSecPinMachine();
			}
			else 
			{
				g_ble_task_flag = BLE_TASK_INIT;
				s_BLE_main_state = S_BLE_IDLE;
			}
		}
		break; 
		
		default:
			g_ble_task_flag = BLE_TASK_INIT;
			s_BLE_main_state = S_BLE_IDLE;
			break;
	}
}

/***************************************************************************
* @fun_name		void BleForcePowerOff(void)
* @brief		BLEǿƶϵ
* @param[in]	None
* @param[out]	None
* @retval		None
* @other		None
***************************************************************************/
void BleForcePowerOff(TYP_POWER_STATUS data)
{
	stc_gpio_cfg_t stcGpioCfg;

	DDL_ZERO_STRUCT(stcGpioCfg);
    //
    stcGpioCfg.enDir = GpioDirIn;    ///< ˿ڷ->
    stcGpioCfg.enDrv = GpioDrvL;     ///< ˿->
    stcGpioCfg.enPu = GpioPuDisable; 
    stcGpioCfg.enPd = GpioPdEnable;  //˿ʹ
    stcGpioCfg.enOD = GpioOdDisable; ///< ˿ڿ©->©ر
    stcGpioCfg.enCtrlMode = GpioAHB; ///< ˿/ֵĴ߿ģʽ->AHB
    Gpio_Init(LPUART1_TX_PORT, LPUART1_TX_PIN, &stcGpioCfg);	
    Gpio_Init(LPUART1_RX_PORT, LPUART1_RX_PIN, &stcGpioCfg);
	
	Gpio_ClrIO(LPUART1_TX_PORT, LPUART1_TX_PIN);
	Gpio_ClrIO(LPUART1_RX_PORT, LPUART1_RX_PIN);
	//
	Gpio_Init(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN, &stcGpioCfg);
	Gpio_ClrIO(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN);	//
	//״̬
	Gpio_Init(BLE_CON_PORT, BLE_CON_PIN, &stcGpioCfg);
	Gpio_ClrIO(BLE_CON_PORT, BLE_CON_PIN);	
	//ſ©
    stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ->
    stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->
    stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
    stcGpioCfg.enPd = GpioPdDisable;
    stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©->©ر
    stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
	Gpio_Init(BLE_POW_PORT, BLE_POW_PIN, &stcGpioCfg);	//ƶ˿
	Gpio_ClrIO(BLE_POW_PORT, BLE_POW_PIN);	//
	
////////////////////////////////////////////
	ble_work_stat.Ble_cur_mode = SLAVE_MODE;
	ble_work_stat.Ble_scan_state = SCAN_END;
	ble_work_stat.Ble_con_state = CON_END;
	s_BLE_init_state = S_BLE_IDLE;			//ϵʼ״̬״̬
	s_BLE_conmgr_state = S_BLE_IDLE;		//ӹ״̬
#if BLE_CENTRAL_SLAVE_MOD	
	s_BLE_scan_state = S_BLE_IDLE;			//ɨ״̬
	s_BLE_mode_switch_state = S_BLE_IDLE;
	s_BLE_white_list_state =  S_BLE_IDLE;
#endif
	s_BLE_at_requeset_state = S_BLE_IDLE;
	s_BLE_change_key_word_state = S_BLE_IDLE;
	s_BLE_update_adv_data_state = S_BLE_IDLE;
	s_BLE_change_mac_state = S_BLE_IDLE;
	s_BLE_change_adv_para_state =  S_BLE_IDLE;
	s_BLE_chk_status_state =  S_BLE_IDLE;
	s_BLE_sec_status_state = S_BLE_IDLE;
	
	flag_ble_force_power=data;//ϵ״̬
}




///*************************************************
//Function:void Ble_TX_Sleep_Init(void)
//Description: ˯ʱTXʼΪⲿж
//Input:  None
//Return: None
//Others:	MainSpaceһӿڣϵʼӿڡ
//*************************************************/
//void Ble_TX_Sleep_Init(void)
//{
//	#if HDSC_HC32_TYPE == HDSC_HC32L13x
//	gpio_cfg_t stcGpioCfg;
//	#else
//	stc_gpio_cfg_t stcGpioCfg;
//	#endif
//    DDL_ZERO_STRUCT(stcGpioCfg);
//    stcGpioCfg.enDir = GpioDirIn;		///< ˿ڷã
//    stcGpioCfg.enDrv = GpioDrvL;		///< ˿->
//    stcGpioCfg.enPu = GpioPuEnable;		///< ˿->
//    stcGpioCfg.enPd = GpioPdDisable;
//    stcGpioCfg.enOD = GpioOdDisable;	///< ˿ڿ©
//    stcGpioCfg.enCtrlMode = GpioAHB;	///< ˿/ֵĴ߿ģʽ->AHB
//	
//	GpioDriverInit(BLE_RX_PORT, BLE_RX_PIN, &stcGpioCfg);
//	Gpio_SetAfMode(BLE_RX_PORT, BLE_RX_PIN, GpioAf0);			//GPIOʼ
//	Gpio_ClearIrq(BLE_RX_PORT, BLE_RX_PIN);
//	Gpio_EnableIrq(BLE_RX_PORT, BLE_RX_PIN, GpioIrqFalling);	//½жϣָʾӶϿ
////	EnableNvic(BLE_RXPORT_IRQ, BLE_RXPORT_PRIORITY, TRUE);		//
//}

/***************************************************************************
 * @fun_name     void BlePreSleep()
 * @brief        ǰ
 * @param[in]    None
 * @param[out]   None
 * @retval       None
 * @other        None
 ***************************************************************************/
void BlePreSleep(void)
{
	if(flag_ble_force_power==BlePowerOk)//״̬
	{
		Gpio_ClrIO(BLE_LOWPOWER_PORT, BLE_LOWPOWER_PIN);	//lowpower
		UartPreSleep(BLE_UART_COM);
	}
}

/***************************************************************************
 * @fun_name    void BleWakeSleep()
 * @brief        ߺ
 * @param[in]    None
 * @param[out]   None
 * @retval       None
 * @other        None
 ***************************************************************************/
void BleWakeSleep(void)
{
}

/***************************************************************************
 * @fun_name     u8 BleIfIdle(void)
 * @brief        ѯģĿ״̬
 * @param[in]    None
 * @param[out]   None
 * @retval       None
 * @other        g_s_Nbiot_main_state(TASK_IDLE:, TASK_IDLEæ)
 ***************************************************************************/
u8 BleIfIdle(void)
{
    if (s_BLE_main_state == S_BLE_IDLE)
    {
        return TASK_IDLE;
    }
    else
    {
        return TASK_BUSY;
    }
}

/***************************************************************************
* @fun_name     u8 BleIfSleep(void)
* @brief        Ƿ
* @param[in]    None
* @param[out]   None
* @retval       TRUE:   FALSE:
* @other        None
***************************************************************************/
u8 BleIfSleep(void)
{
	//״̬IDLEδӡδ㲥ģʽŵƽΪͣ
    if ((s_BLE_main_state == S_BLE_IDLE) && (FALSE == Gpio_GetInputIO(BLE_CON_PORT, BLE_CON_PIN)))
    {
        return TASK_IDLE;
    }
    else
    {
        return TASK_BUSY;
    }
}

/***************************************************************************
* @fun_name     u8 CheckMetAddrIfInit(void)
* @brief        ѯַǷ
* @param[in]    None
* @param[out]   None
* @retval       TRUE:   FALSE:
* @other        δñַǰĬȫΪ0ʼʱıƺMAC
***************************************************************************/
u8 CheckMetAddrIfInit(void)
{
	u8 temp_i = 0;
	for(temp_i = 0; temp_i < 7; temp_i++)
	{
		if(0 !=Sys_data_object.P1.met_addr[temp_i])
		{
			 return TRUE;
		}
	}
	return FALSE;
}

void BleGetFirmVerson(u8* verson_addr)
{
	*(verson_addr) = ble_work_stat.Ble_softverson[0];
	*(verson_addr + 1) = ble_work_stat.Ble_softverson[1];
}

void BleGetCurMacAddr(u8 *cur_mac)
{
	u8 i = 0;
	for(i = 0; i < 6; i++)
	{
		*(cur_mac + i) = ble_work_stat.Ble_mac[i];
	}
}
void BleClearResetCount(void)
{
	ble_reset_count=0;
}
TYP_POWER_STATUS BleGetPowerState(void)
{
	return flag_ble_force_power;
}
/****************************************************************************
//жϺݸʵҪѡʹãPORTܹãط
//жϽӿ
****************************************************************************/
///*************************************************
//Function:void BLE_CONorRX_IRQHandler(void)
//Description: ӺͽжϺ
//Input:  None
//Return: None
//Others:
// *************************************************/
void BLE_CONorRX_IRQHandler(void)
{
	if (TRUE == Gpio_GetIrqStatus(BLE_CON_PORT, BLE_CON_PIN))	//Connect_Detect
	{
		Gpio_ClearIrq(BLE_CON_PORT, BLE_CON_PIN);
		if(Gpio_GetInputIO(BLE_CON_PORT, BLE_CON_PIN))			//ߵƽʾ
		{
			ble_con_msg = BLE_CON_MSG;
		}
		else
		{
			ble_con_msg = BLE_DISCON_MSG;
		}
	}
}

UNION_4U8TOU32 net_state_data;
u32 sys_get_net_state(void)
{
	net_state_data.data_buf[0] = 4;//״̬־
	net_state_data.data_buf[1] = flag_ble_force_power;//״̬:0,;1,ǿƶϵ;2,ģʽϵ״̬
	net_state_data.data_buf[2] = ble_reset_count;//Ѹλ
	return net_state_data.datas;;
}

#ifdef	__cplusplus
}
#endif
#endif
